Class extends Part

Class constructor($name : Text; $prefix : Text; $spec : Variant; $style : Object; $userActions : Object)
	
	var $specObj : Object
	
	Case of 
		: (Value type:C1509($spec)=Is object:K8:27)
			
			$specObj:=$spec
			
		: (Value type:C1509($spec)=Is text:K8:3)
			
			var $textSpec : Text
			$textSpec:=$spec
			
			If ($textSpec#"-")
				$specObj:=New object:C1471("action"; $textSpec)
			Else 
				$specObj:=New object:C1471("title"; $textSpec)
			End if 
			
	End case 
	
	Super:C1705($name; $prefix; $specObj; $style)
	
	var $actionName : Text
	$actionName:=$specObj["action"]
	
	var $action : cs:C1710.Action
	If ($userActions#Null:C1517)
		$action:=$userActions[$actionName]
	End if 
	
	If ($action=Null:C1517)
		$action:=Storage:C1525.builtinActions[$actionName]
	End if 
	
	
	This:C1470.action:=$action
	This:C1470.title:=$specObj["title"]
	This:C1470.icon:=$specObj["icon"]
	
	If ((This:C1470.title=Null:C1517) & (This:C1470.action#Null:C1517))
		This:C1470.title:=This:C1470.action.title
	End if 
	
	If ((This:C1470.icon=Null:C1517) & (This:C1470.action#Null:C1517))
		This:C1470.icon:=This:C1470.action.icon
	End if 
	
	If ($specObj.items#Null:C1517)
		
		This:C1470.items:=New collection:C1472()
		
		var $subItemSpec : Variant
		For each ($subItemSpec; $specObj["items"])
			
			var $subItem : cs:C1710.MenuItem
			$subItem:=cs:C1710.MenuItem.new($subItemSpec; $userActions)
			
			If ($subItem.validate())
				This:C1470.items.push($subItem)
			End if 
			
		End for each 
		
	End if 
	
	
Function validate()->$valid : Boolean
	
	// FIXME: Alert if action not defined in dev mode
	$valid:=This:C1470.action#Null:C1517
	
	
Function getActions()->$actions : Collection
	
	$actions:=Choose:C955(This:C1470.action#Null:C1517; New collection:C1472(This:C1470.action); New collection:C1472())
	If (This:C1470.items#Null:C1517)
		
		var $subItem : cs:C1710.ActionPart
		For each ($subItem; This:C1470.items)
			
			var $subActions : Collection
			$subActions:=$subItem.getActions()
			
			$actions:=$actions.combine($subActions)
			
		End for each 
		
	End if 
	