Class extends Widget

Class constructor($controlName : Text; $areaName : Text)
	
	Super:C1705($controlName)
	
	This:C1470.areaName:=""
	This:C1470.areaRef:=0
	This:C1470.areaBounds:=Null:C1517
	
	This:C1470.actions:=Null:C1517
	This:C1470.style:=Null:C1517
	This:C1470.menubar:=Null:C1517
	This:C1470.toolbar:=Null:C1517
	This:C1470.sidebar:=Null:C1517
	
	This:C1470.actionStates:=Null:C1517
	
	This:C1470.callbackContext:=Null:C1517
	
	This:C1470.state.pendingAreaVisibility:=False:C215
	This:C1470.state.pendingAreaLayout:=False:C215
	
	This:C1470.innerWidget:=Null:C1517
	
	This:C1470.thumbnailController:=Null:C1517
	This:C1470.thumbnails:=Null:C1517
	
	This:C1470.bookmarkController:=Null:C1517
	
	This:C1470.currentThumbnailIndex:=-1
	This:C1470.currentThumbnail:=Null:C1517
	This:C1470.selectedThumbnails:=Null:C1517
	
	This:C1470._checkBuiltinActionStorage()
	This:C1470._checkBuiltinStyleStorage()
	
	This:C1470.prefs:=New object:C1471()
	
	C_POINTER:C301($areaPtr)
	$areaPtr:=OBJECT Get pointer:C1124(Object named:K67:5; $areaName)
	
	If (Not:C34(Is nil pointer:C315($areaPtr)))
		
		C_LONGINT:C283($areaRef)
		$areaRef:=$areaPtr->
		
		This:C1470.areaName:=$areaName
		This:C1470.areaRef:=$areaRef
		
		OBJECT SET RESIZING OPTIONS:C1175(*; This:C1470.areaName; Resize horizontal grow:K42:8; Resize vertical grow:K42:11)
		
		If (This:C1470.state.pendingVisibility)
			This:C1470.state.pendingAreaVisibility:=True:C214
			OBJECT SET VISIBLE:C603(*; This:C1470.areaName; False:C215)
		End if 
		
	End if 
	
	If (This:C1470.controlName#Null:C1517)
		
		This:C1470.innerWidget:=cs:C1710.InnerImgWidget.new(This:C1470)
		This:C1470.thumbnailController:=cs:C1710.ThumbnailController.new(This:C1470)
		This:C1470.bookmarkController:=cs:C1710.BookmarkController.new(This:C1470)
		
		This:C1470.callbackContext:=cs:C1710.CallbackContext.new(This:C1470)
		
	End if 
	
	
Function cleanup()
	
	Super:C1706.cleanup()
	
	If (This:C1470.thumbnailController#Null:C1517)
		This:C1470.thumbnailController.cleanup()
		This:C1470.thumbnailController:=Null:C1517
	End if 
	
	If (This:C1470.bookmarkController#Null:C1517)
		This:C1470.bookmarkController.cleanup()
		This:C1470.bookmarkController:=Null:C1517
	End if 
	
	
Function _checkThumbList()
	
	If (Not:C34(This:C1470.thumbnailController.isSetup))
		
		This:C1470.setupThumbList()
		
	End if 
	
	
Function _checkTOCList()
	
	If (Not:C34(This:C1470.bookmarkController.isSetup))
		
		This:C1470.setupTOCList()
		
	End if 
	
	
Function _restoreAreaVisibility()
	If (This:C1470.state.pendingAreaVisibility)
		This:C1470.state.pendingAreaVisibility:=False:C215
		If (This:C1470.areaName#"")
			OBJECT SET VISIBLE:C603(*; This:C1470.areaName; This:C1470.initiallyVisible)
		End if 
	End if 
	
	
Function _applyPendingAreaLayout()
	
	This:C1470.state.pendingAreaLayout:=False:C215
	This:C1470._applyAreaLayout()
	
	
Function _checkBuiltinActionStorage()
	
	If (Storage:C1525.builtinActions=Null:C1517)
		
		var $builtinsFile : 4D:C1709.File
		$builtinsFile:=File:C1566("/RESOURCES/Q2Pix/Q2ImgControl/Builtins/BuiltinActions.json"; fk posix path:K87:1)
		
		var $builtinActions : Object
		$builtinActions:=cs:C1710.ActionDict.new($builtinsFile)
		
		Use (Storage:C1525)
			
			Storage:C1525.builtinActions:=OB Copy:C1225($builtinActions; ck shared:K85:29)
			
		End use 
		
	End if 
	
	
Function _checkBuiltinStyleStorage()
	
	If (Storage:C1525.builtinStyle=Null:C1517)
		
		var $builtinStyle : cs:C1710.Style
		$builtinStyle:=cs:C1710.Style.new()
		
		Use (Storage:C1525)
			
			Storage:C1525.builtinStyle:=OB Copy:C1225($builtinStyle; ck shared:K85:29)
			
		End use 
		
	End if 
	
	
Function _loadConfigFromFile($configFile : 4D:C1709.File)->$config : Object
	
	var $localConfig : Object
	If (File_LoadJSON($configFile; ->$localConfig))
		$config:=$localConfig
	End if 
	
	
Function setup($config : Variant)->$success : Boolean
	
	$success:=False:C215
	
	var $configObj : Object
	
	var $configType : Integer
	$configType:=Value type:C1509($config)
	
	Case of 
		: (($configType=Is null:K8:31) | ($configType=Is undefined:K8:13))  // Use default config
			
			var $defaultPath : Text
			$defaultPath:="/RESOURCES/Q2Pix/Q2ImgControl/Builtins/BuiltinConfig.json"
			
			var $defaultFile : 4D:C1709.File
			$defaultFile:=File:C1566($defaultPath; fk posix path:K87:1)
			
			$configObj:=This:C1470._loadConfigFromFile($defaultFile)
			
		: ($configType=Is object:K8:27)
			
			If (OB Instance of:C1731($config; 4D:C1709.File))  // Load config from specified file
				
				$configObj:=This:C1470._loadConfigFromFile($config)
				
			Else   // Use specified config
				
				$configObj:=$config
				
			End if 
			
		: ($configType=Is text:K8:3)  // Load config from specified posix path
			
			var $configFile : 4D:C1709.File
			$configFile:=File:C1566(String:C10($config); fk posix path:K87:1)
			
			$configObj:=This:C1470._loadConfigFromFile($configFile)
			
	End case 
	
	// FIXME: Update json schema and validate
	
	$success:=($configObj#Null:C1517)
	
	Super:C1706.setup($configObj)
	
	This:C1470._buildActionStates()
	
	If (This:C1470.onCurrentPage())
		
		If (This:C1470.state.pendingAreaVisibility)
			OB_CallForm(This:C1470; This:C1470._restoreAreaVisibility)
		End if 
		
		OB_CallForm(This:C1470; This:C1470._updateState)
		
	End if 
	
	
Function _buildActionStates()
	
	This:C1470.actionStates:=New object:C1471()
	
	If (This:C1470.menubar#Null:C1517)
		
		var $menu : Object
		For each ($menu; This:C1470.menubar.menus)
			
			If ($menu.visible)
				
				var $menuActions : Collection
				$menuActions:=$menu.getActions()
				
				var $action : cs:C1710.Action
				For each ($action; $menuActions)
					
					If (This:C1470.actionStates[$action.name]=Null:C1517)
						This:C1470.actionStates[$action.name]:=New object:C1471("action"; $action)
					End if 
					
				End for each 
				
			End if 
			
		End for each 
		
	End if 
	
	If (This:C1470.toolbar#Null:C1517)
		
		var $toolset : Object
		For each ($toolset; This:C1470.toolbar.toolsets)
			
			If ($toolset.visible)
				
				var $tool : Object
				For each ($tool; $toolset.tools)
					
					var $toolActions : Collection
					$toolActions:=$tool.getActions()
					
					var $action : cs:C1710.Action
					For each ($action; $toolActions)
						
						If (This:C1470.actionStates[$action.name]=Null:C1517)
							This:C1470.actionStates[$action.name]:=New object:C1471("action"; $action)
						End if 
						
					End for each 
					
				End for each 
				
			End if 
			
		End for each 
		
	End if 
	
	
Function _updateState()
	
	If (This:C1470.actionStates#Null:C1517)
		
		// Call action methods and store states
		
		This:C1470.callbackContext.setup()
		
		var $actionName : Text
		For each ($actionName; This:C1470.actionStates)
			
			var $actionState : Object
			$actionState:=This:C1470.actionStates[$actionName]
			
			var $action : cs:C1710.Action
			$action:=$actionState.action
			
			var $status : Object
			$status:=$action.call("status"; This:C1470.callbackContext)
			
			$actionState.status:=$status
			
		End for each 
		
		This:C1470.callbackContext.cleanup()
		
		// Apply states
		OB_ExecuteInSubform(This:C1470.controlName; This:C1470.innerWidget; This:C1470.innerWidget._applyState)
		
	End if 
	
	
Function _performAction($actionName : Text; $args : Object)
	
	var $actionStatus : Object
	$actionStatus:=This:C1470.actionStates[$actionName].status
	$actionStatus:=Choose:C955($actionStatus#Null:C1517; $actionStatus; New object:C1471())
	
	var $enabled : Boolean
	$enabled:=Choose:C955($actionStatus.enabled#Null:C1517; $actionStatus.enabled; False:C215)
	
	If ($enabled)
		
		This:C1470.callbackContext.setup($args)
		
		var $action : cs:C1710.Action
		$action:=This:C1470.actionStates[$actionName].action
		
		var $result : Object
		$result:=$action.call("action"; This:C1470.callbackContext)
		
		This:C1470.callbackContext.cleanup()
		
		This:C1470._updateState()
		
	End if 
	
	
Function _postMessage($what : Text; $data : Object)
	
	OB_CallForm(This:C1470; This:C1470._handleMessage; \
		Choose:C955($data#Null:C1517; \
		New collection:C1472($what; $data); \
		New collection:C1472($what)))
	
	
Function _handleMessage($what : Text; $data : Object)
	
	Case of 
		: ($what="ImageLoaded")
			
			OB REMOVE:C1226(This:C1470.prefs; "savingOptions")
			This:C1470.setupThumbList()
			This:C1470.setupTOCList()
			
		: ($what="ImageUnloaded")
			
			This:C1470.cleanupThumbList()
			This:C1470.cleanupTOCList()
			
		: ($what="ImageSaved")
			
			This:C1470.setupThumbList()
			This:C1470.setupTOCList()
			
		: ($what="ImageReloaded")
			
			This:C1470.setupThumbList()
			This:C1470.setupTOCList()
			
		: ($what="FrameChanged")
			
			This:C1470.reloadCurrentThumb()
			
		: ($what="FrameIndex")
			
			This:C1470.syncThumbList()
			This:C1470.syncTOCList()
			
	End case 
	
	
Function setupThumbList()
	
	If (This:C1470.onCurrentPage() & (This:C1470.sidebar#Null:C1517))
		
		If (This:C1470.sidebar.visible & (This:C1470.sidebar.view="thumbs"))
			
			This:C1470.thumbnailController.setup(This:C1470.style)
			
		End if 
		
	End if 
	
	
Function cleanupThumbList()
	
	This:C1470.thumbnailController.clear()
	
	
Function reloadCurrentThumb()
	
	
Function syncThumbList()
	
	If (This:C1470.onCurrentPage() & (This:C1470.sidebar#Null:C1517))
		
		If (This:C1470.sidebar.visible & (This:C1470.sidebar.view="thumbs"))
			
			If (This:C1470.thumbnailController.isSetup)
				
				var $frameIdx : Integer
				$frameIdx:=ImgArea_GetFrameIndex:P11667:42(This:C1470.areaRef)
				
				This:C1470.thumbnailController.syncCurrentThumb($frameIdx)
				
			End if 
			
		End if 
		
	End if 
	
	
	
Function setupTOCList()
	
	If (This:C1470.onCurrentPage() & (This:C1470.sidebar#Null:C1517))
		
		If (This:C1470.sidebar.visible & (This:C1470.sidebar.view="TOC"))
			
			This:C1470.bookmarkController.cleanup()
			
			var $docRef : Text
			$docRef:=ImgArea_GetDocument:P11667:41(This:C1470.areaRef)
			If ($docRef#"")
				
				var $format : Text
				$format:=ImgDoc_GetFormat:P11667:9($docRef)
				If ($format="PDF")
					
					var $boolmarks : Collection
					$boolmarks:=PDFDoc_GetBookmarks:P11667:33($docRef)
					
					This:C1470.bookmarkController.setup($boolmarks)
					
				End if 
				
				ImgObj_Release:P11667:133($docRef)
			End if 
			
		End if 
		
	End if 
	
	
Function cleanupTOCList()
	
	This:C1470.bookmarkController.cleanup()
	
	
Function syncTOCList()
	
	If (This:C1470.onCurrentPage() & (This:C1470.sidebar#Null:C1517))
		
		If (This:C1470.sidebar.visible & (This:C1470.sidebar.view="TOC"))
			
			If (This:C1470.bookmarkController.isSetup)
				
				var $frameIdx : Integer
				$frameIdx:=ImgArea_GetFrameIndex:P11667:42(This:C1470.areaRef)
				
				This:C1470.bookmarkController.syncCurrentPage($frameIdx)
				
			End if 
			
		End if 
		
	End if 
	
	
Function _buildControls()->$success : Boolean
	
	This:C1470.actions:=Null:C1517
	This:C1470.style:=Null:C1517
	This:C1470.menubar:=Null:C1517
	This:C1470.toolbar:=Null:C1517
	This:C1470.sidebar:=Null:C1517
	
	
	If (This:C1470.config["actions"]#Null:C1517)
		This:C1470.actions:=cs:C1710.ActionDict.new(This:C1470.config["actions"])
	End if 
	
	
	If (This:C1470.config["style"]#Null:C1517)
		This:C1470.style:=cs:C1710.Style.new(This:C1470.config["style"])
	End if 
	If (This:C1470.style=Null:C1517)
		This:C1470.style:=Storage:C1525.builtinStyle
	End if 
	
	
	If (This:C1470.config["menubar"]#Null:C1517)
		
		var $menubar : cs:C1710.Menubar
		$menubar:=cs:C1710.Menubar.new(This:C1470.config["menubar"]; This:C1470.style; This:C1470.actions)
		If ($menubar.validate())
			This:C1470.menubar:=$menubar
		End if 
		
	End if 
	
	
	If (This:C1470.config["toolbar"]#Null:C1517)
		
		var $toolbar : cs:C1710.Toolbar
		$toolbar:=cs:C1710.Toolbar.new(This:C1470.config["toolbar"]; This:C1470.style; This:C1470.actions)
		If ($toolbar.validate())
			This:C1470.toolbar:=$toolbar
		End if 
		
	End if 
	
	
	If (This:C1470.config["sidebar"]#Null:C1517)
		
		var $sidebar : cs:C1710.Sidebar
		$sidebar:=cs:C1710.Sidebar.new(This:C1470.config["sidebar"]; This:C1470.style)
		If ($sidebar.validate())
			This:C1470.sidebar:=$sidebar
		End if 
		
	End if 
	
	$success:=True:C214
	
	
Function _buildLayout()->$success : Boolean
	
	var $curX; $curY; $height : Integer
	$curX:=0
	$curY:=0
	
	If (This:C1470.menubar#Null:C1517)
		This:C1470.menubar.layout(This:C1470.controlWidth; This:C1470.controlHeight; $curX; $curY)
		If (This:C1470.menubar.effectivelyVisible())
			$curY:=$curY+This:C1470.menubar.bounds.height
		End if 
	End if 
	
	If (This:C1470.toolbar#Null:C1517)
		This:C1470.toolbar.layout(This:C1470.controlWidth; This:C1470.controlHeight; $curX; $curY)
		If (This:C1470.toolbar.effectivelyVisible())
			$curY:=$curY+This:C1470.toolbar.bounds.height
		End if 
	End if 
	
	If (This:C1470.sidebar#Null:C1517)
		This:C1470.sidebar.layout(This:C1470.controlWidth; This:C1470.controlHeight; $curX; $curY)
		If (This:C1470.sidebar.effectivelyVisible())
			$curX:=$curX+This:C1470.sidebar.bounds.width
			$curY:=$curY/*+This.sidebar.bounds.height*/
		End if 
	End if 
	
	$success:=True:C214
	
	
Function applyLayout()->$success : Boolean
	
	Super:C1706.applyLayout()
	
	This:C1470._applyAreaLayout()
	
	This:C1470._checkThumbList()
	This:C1470._checkTOCList()
	
	
Function _applyAreaLayout()
	
	var $controlLeft; $controlTop; $controlRight; $controlBottom : Integer
	OBJECT GET COORDINATES:C663(*; This:C1470.controlName; $controlLeft; $controlTop; $controlRight; $controlBottom)
	
	var $areaLeft; $areaTop; $areaRight; $areaBottom : Integer
	$areaLeft:=$controlLeft
	$areaTop:=$controlTop
	$areaRight:=$controlRight
	$areaBottom:=$controlBottom
	
	var $usedWidth; $usedHeight : Integer
	$usedWidth:=0
	$usedHeight:=0
	
	If (This:C1470.menubar#Null:C1517)
		If (This:C1470.menubar.effectivelyVisible())
			$areaTop:=$controlTop+This:C1470.menubar.bounds.y+This:C1470.menubar.bounds.height
			$usedHeight:=$usedHeight+This:C1470.menubar.bounds.height
		End if 
	End if 
	
	If (This:C1470.toolbar#Null:C1517)
		If (This:C1470.toolbar.effectivelyVisible())
			$areaTop:=$controlTop+This:C1470.toolbar.bounds.y+This:C1470.toolbar.bounds.height
			$usedHeight:=$usedHeight+This:C1470.toolbar.bounds.height
		End if 
	End if 
	
	If (This:C1470.sidebar#Null:C1517)
		If (This:C1470.sidebar.effectivelyVisible())
			$areaLeft:=$controlLeft+This:C1470.sidebar.bounds.x+This:C1470.sidebar.bounds.width
			$usedWidth:=$usedWidth+This:C1470.sidebar.bounds.width
		End if 
	End if 
	
	$areaLeft:=$controlLeft+$usedWidth
	$areaTop:=$controlTop+$usedHeight
	$areaRight:=$controlRight
	$areaBottom:=$controlBottom
	
	OBJECT SET COORDINATES:C1248(*; This:C1470.areaName; $areaLeft; $areaTop+1; $areaRight; $areaBottom-1)
	
	
Function resize()
	
	Super:C1706.resize()
	
	OB_ExecuteInSubform(This:C1470.controlName; This:C1470.thumbnailController; This:C1470.thumbnailController._startTasking)
	
	// =========================================
	
Function _buildMenu($menuItems : Collection)->$menuRef : Text
	
	$menuRef:=Create menu:C408()
	
	var $item : cs:C1710.MenuItem
	For each ($item; $menuItems)
		
		var $action : cs:C1710.Action
		$action:=$item.action
		
		Case of 
			: ($action=Null:C1517)  // Separator
				
				APPEND MENU ITEM:C411($menuRef; "(-")
				DISABLE MENU ITEM:C150($menuRef; -1)
				
			Else 
				
				var $actionName : Text
				$actionName:=$action.name
				
				var $actionStatus : Object
				$actionStatus:=This:C1470.actionStates[$actionName].status
				$actionStatus:=Choose:C955($actionStatus#Null:C1517; $actionStatus; New object:C1471())
				
				var $visible; $enabled; $checked : Boolean
				$visible:=Choose:C955($actionStatus.visible#Null:C1517; $actionStatus.visible; True:C214)
				$enabled:=Choose:C955($actionStatus.enabled#Null:C1517; $actionStatus.enabled; False:C215)
				$checked:=Choose:C955($actionStatus.checked#Null:C1517; $actionStatus.checked; False:C215)
				
				If ($visible)
					
					var $subMenu : Text
					If ($item.items#Null:C1517)
						$subMenu:=This:C1470._buildMenu($item.items)
						APPEND MENU ITEM:C411($menuRef; $item.title; $subMenu)
						RELEASE MENU:C978($subMenu)
					Else 
						APPEND MENU ITEM:C411($menuRef; $item.title)
					End if 
					
					If ($enabled)
						ENABLE MENU ITEM:C149($menuRef; -1)
					Else 
						DISABLE MENU ITEM:C150($menuRef; -1)
					End if 
					
					SET MENU ITEM PARAMETER:C1004($menuRef; -1; $actionName)
					
					If ($checked)
						SET MENU ITEM MARK:C208($menuRef; -1; Char:C90(18))
					End if 
					
				End if 
				
		End case 
		
	End for each 
	
	
Function _saveDoc($docRef : Text; $destPath : Text; $options : Object; \
$promptOptions : Boolean; $promptFile : Boolean)->$success : Integer
	
	var $continue : Boolean
	$continue:=True:C214
	
	If ($promptOptions)
		$continue:=(ImgDlog_SavingOptions($docRef; ->$options)=1)
	End if 
	
	If ($continue & $promptFile)
		
		var $destFormat : Text
		$destFormat:=$options.Format
		
		var $destFormatInfo : Object
		$destFormatInfo:=ImgFormat_GetInfo($destFormat)
		
		var $destExtension : Text
		$destExtension:=$destFormatInfo.Extensions[0]
		
		var $filePath : Text
		$filePath:=ImgDoc_GetFilePath($docRef)
		
		var $defaultName : Text
		
		If ($filePath#"")
			
			var $fileObject : 4D:C1709.File
			$fileObject:=File:C1566($filePath; fk posix path:K87:1)
			
			$defaultName:=$fileObject.name
			
		Else 
			$defaultName:="Image"
		End if 
		
		ARRAY TEXT:C222($selectedFilePaths; 0)
		var $selectedFileName : Text
		
		$selectedFileName:=Select document:C905(\
			$defaultName; \
			"."+$destExtension; \
			"Save image"; \
			File name entry:K24:17; \
			$selectedFilePaths)
		If ($selectedFileName#"")
			
			$destPath:=Convert path system to POSIX:C1106($selectedFilePaths{1})
			$continue:=True:C214
			
		Else 
			$continue:=False:C215
		End if 
		
	End if 
	
	If ($continue & ($destPath#""))
		
		If (ImgDoc_SaveInFile($docRef; $destPath; $options)=1)
			
			This:C1470.prefs.savingOptions:=$options
			
			This:C1470._postMessage("ImageSaved")
			$success:=1
			
		Else 
			// FIXME: report error
		End if 
		
	End if 
	
	
	// =========================================
	
Function isVisible()->$visible : Boolean
	
	$visible:=False:C215
	
	
Function setVisible($visible : Boolean)
	Super:C1706.setVisible($visible)
	If (This:C1470.pendingVisibility)
		// Do nothing - area already hidden
	Else 
		If (This:C1470.areaName#"")
			OBJECT SET VISIBLE:C603(*; This:C1470.areaName; This:C1470.visible)
		End if 
	End if 
	
	
Function show()
	
	This:C1470.setVisible(True:C214)
	
	
Function hide()
	
	This:C1470.setVisible(False:C215)
	
	
	// =========================================
	
Function isPartVisible($part : Text)->$visible : Boolean
	
	$visible:=False:C215
	
	Case of 
		: ($part="menubar")
			
			If (This:C1470.menubar#Null:C1517)
				$visible:=This:C1470.menubar.visible
			End if 
			
		: ($part="toolbar")
			
			If (This:C1470.toolbar#Null:C1517)
				$visible:=This:C1470.toolbar.visible
			End if 
			
		: ($part="sidebar")
			
			If (This:C1470.sidebar#Null:C1517)
				$visible:=This:C1470.sidebar.visible
			End if 
			
	End case 
	
	
Function setPartVisible($part : Text; $visible : Boolean)
	
	var $update : Boolean
	$update:=False:C215
	
	Case of 
		: ($part="menubar")
			
			If (This:C1470.menubar#Null:C1517)
				If ($visible#This:C1470.menubar.visible)
					This:C1470.menubar.visible:=$visible
					$update:=True:C214
				End if 
			End if 
			
		: ($part="toolbar")
			
			If (This:C1470.toolbar#Null:C1517)
				If ($visible#This:C1470.toolbar.visible)
					This:C1470.toolbar.visible:=$visible
					$update:=True:C214
				End if 
			End if 
			
		: ($part="sidebar")
			
			If (This:C1470.sidebar#Null:C1517)
				If ($visible#This:C1470.sidebar.visible)
					This:C1470.sidebar.visible:=$visible
					$update:=True:C214
				End if 
			End if 
			
	End case 
	
	If ($update)
		
		This:C1470._buildLayout()
		
		If (This:C1470.onCurrentPage())
			This:C1470.applyLayout()
		Else 
			This:C1470.state.layoutApplied:=False:C215
		End if 
		
		This:C1470._updateState()
		
	End if 
	
	
	// =========================================
	
Function isMenuVisible($name : Text)->$visible : Boolean
	
	$visible:=False:C215
	
	If (This:C1470.menubar#Null:C1517)
		
		var $menu : cs:C1710.Menu
		$menu:=This:C1470.menubar.getMenu($name)
		If ($menu#Null:C1517)
			$visible:=$menu.visible
		End if 
	End if 
	
	
Function setMenuVisible($name : Text; $visible : Boolean)
	
	var $update : Boolean
	$update:=False:C215
	
	If (This:C1470.menubar#Null:C1517)
		
		var $menu : cs:C1710.Menu
		$menu:=This:C1470.menubar.getMenu($name)
		If ($menu#Null:C1517)
			If ($visible#$menu.visible)
				$menu.visible:=$visible
				$update:=True:C214
			End if 
		End if 
	End if 
	
	If ($update)
		
		This:C1470._buildLayout()
		
		If (This:C1470.onCurrentPage())
			This:C1470.applyLayout()
		Else 
			This:C1470.state.layoutApplied:=False:C215
		End if 
		
		This:C1470._updateState()
		
	End if 
	
	
	// =========================================
	
Function isToolsetVisible($name : Text)->$visible : Boolean
	
	$visible:=False:C215
	
	If (This:C1470.toolbar#Null:C1517)
		
		var $toolset : cs:C1710.Toolset
		$toolset:=This:C1470.toolbar.getToolset($name)
		If ($toolset#Null:C1517)
			$visible:=$toolset.visible
		End if 
		
	End if 
	
Function setToolsetVisible($name : Text; $visible : Boolean)
	
	var $update : Boolean
	$update:=False:C215
	
	If (This:C1470.toolbar#Null:C1517)
		
		var $toolset : cs:C1710.Toolset
		$toolset:=This:C1470.toolbar.getToolset($name)
		If ($toolset#Null:C1517)
			If ($visible#$toolset.visible)
				$toolset.visible:=$visible
				$update:=True:C214
			End if 
		End if 
		
	End if 
	
	If ($update)
		
		This:C1470._buildLayout()
		
		If (This:C1470.onCurrentPage())
			This:C1470.applyLayout()
		Else 
			This:C1470.state.layoutApplied:=False:C215
		End if 
		
		This:C1470._updateState()
		
	End if 
	
	// =========================================
	
Function getSidebarView()->$view : Text
	
	$view:=""
	
	If (This:C1470.sidebar#Null:C1517)
		$view:=This:C1470.sidebar.view
	End if 
	
	
Function setSidebarView($view : Text)
	
	var $update : Boolean
	$update:=False:C215
	
	If (This:C1470.sidebar#Null:C1517)
		
		If ($view#This:C1470.sidebar.view)
			This:C1470.sidebar.view:=$view
			$update:=True:C214
		End if 
		
	End if 
	
	If ($update)
		
		This:C1470._buildLayout()
		
		If (This:C1470.onCurrentPage())
			This:C1470.applyLayout()
		Else 
			This:C1470.state.layoutApplied:=False:C215
		End if 
		
		This:C1470._updateState()
		
		This:C1470.syncThumbList()
		This:C1470.syncTOCList()
		
	End if 
	
	// =========================================
	
Function setDocumentRef($docRef : Text; $frameIndex : Integer)->$success : Integer
	
	// Check for an already assigned doc
	var $existingDoc : Text
	$existingDoc:=ImgArea_GetDocument:P11667:41(This:C1470.areaRef)
	If ($existingDoc#"")
		
		ImgArea_SetDocument:P11667:40(This:C1470.areaRef; "")  // Unload existing doc
		
		This:C1470._postMessage("ImageUnloaded")
		
	End if 
	
	$success:=ImgArea_SetDocument:P11667:40(This:C1470.areaRef; $docRef; $frameIndex)
	If ($success=1)
		
		This:C1470._postMessage("ImageLoaded")
		
	End if 
	
	If ($existingDoc#"")
		// Was retained with the ImgArea_GetDocument() call above
		ImgObj_Release:P11667:133($existingDoc)
	End if 
	
	This:C1470._updateState()
	
	
Function getDocumentRef()->$docRef : Text
	
	$docRef:=ImgArea_GetDocument:P11667:41(This:C1470.areaRef)
	
	
Function setImageFile($imageFile : Variant; $frameIndex : Integer)->$success : Integer
	
	var $imagePath : Text
	
	Case of 
		: (Value type:C1509($imageFile)=Is object:K8:27)
			
			var $fileObject : Object
			$fileObject:=$imageFile
			
			If (OB Class:C1730($fileObject)=4D:C1709.file)
				$imagePath:=$fileObject.path
			End if 
			
		: (Value type:C1509($imageFile)=Is text:K8:3)
			
			$imagePath:=$imageFile
			
	End case 
	
	var $docRef : Text
	$docRef:=ImgDoc_CreateWithFile($imagePath)
	If ($docRef#"")
		
		This:C1470.setDocumentRef($docRef; $frameIndex)
		
		ImgObj_Release:P11667:133($docRef)
		
	End if 
	
	
Function getImagePath()->$imagePath : Text
	
	
Function getImageFile()->$imageFile : 4D:C1709.File
	
	
Function setImageData($imageData : Blob; $frameIndex : Integer)->$success : Integer
	
	var $docRef : Text
	$docRef:=ImgDoc_CreateWithBLOB(->$imageData)
	If ($docRef#"")
		
		$success:=This:C1470.setDocumentRef($docRef; $frameIndex)
		
		ImgObj_Release:P11667:133($docRef)
		
	End if 
	
	
Function setPicture($pict : Picture; $frameIndex : Integer)->$success : Integer
	
	var $docRef : Text
	$docRef:=ImgDoc_CreateWithPicture(->$pict)
	If ($docRef#"")
		
		$success:=This:C1470.setDocumentRef($docRef; $frameIndex)
		
		ImgObj_Release:P11667:133($docRef)
		
	End if 
	
	
	// =========================================
	
Function setFrameIndex($frameIndex : Integer)->$success : Integer
	
	$success:=ImgArea_SetFrameIndex:P11667:43(This:C1470.areaRef; $frameIndex)
	
	This:C1470._postMessage("FrameIndex")
	
	This:C1470._updateState()
	
	
Function getFrameIndex()->$frameIndex : Integer
	
	$frameIndex:=ImgArea_GetFrameIndex:P11667:42(This:C1470.areaRef)
	
	
	// =========================================
	
	