Class extends InnerWidget

Class constructor($widget : cs:C1710.ImgWidget)
	
	Super:C1705($widget)
	
	
Function _postApplyAreaLayout()
	
	If (Not:C34(This:C1470.widget.state.pendingAreaLayout))
		This:C1470.widget.state.pendingAreaLayout:=True:C214
		OB_CallForm(This:C1470.widget; This:C1470.widget._applyPendingAreaLayout)
	End if 
	
	
Function _applyState()
	
	var $widget : cs:C1710.ImgWidget
	$widget:=This:C1470.widget
	
	If ($widget.toolbar#Null:C1517)
		
		var $toolset : Object
		For each ($toolset; $widget.toolbar.toolsets)
			
			If ($toolset.visible)
				
				var $tool : Object
				For each ($tool; $toolset.tools)
					
					var $actionName : Text
					$actionName:=$tool.action.name
					
					var $actionState : Object
					$actionState:=$widget.actionStates[$actionName].status
					$actionState:=Choose:C955($actionState#Null:C1517; $actionState; New object:C1471())
					
					var $enabled : Boolean
					$enabled:=Choose:C955($actionState.enabled#Null:C1517; $actionState.enabled; False:C215)
					
					Case of 
						: ($tool.type="input")
							
							OBJECT SET ENTERABLE:C238(*; $tool.formObject; $enabled)
							
							Case of 
								: ($tool.input.valueType="integer")
									
									Case of 
										: ($actionState.displayValue#Null:C1517)
											OBJECT SET VALUE:C1742($tool.formObject; String:C10($actionState.displayValue))
										: ($actionState.value#Null:C1517)
											OBJECT SET VALUE:C1742($tool.formObject; String:C10(Int:C8(Num:C11($actionState.value))))
										Else 
											OBJECT SET VALUE:C1742($tool.formObject; "")
									End case 
									
								: ($tool.input.valueType="number")
									
									// FIXME: number input implementation
									
								: ($tool.input.valueType="percent")
									
									Case of 
										: ($actionState.displayValue#Null:C1517)
											OBJECT SET VALUE:C1742($tool.formObject; String:C10($actionState.displayValue))
										: ($actionState.value#Null:C1517)
											OBJECT SET VALUE:C1742($tool.formObject; String:C10(Int:C8(Num:C11($actionState.value))))
										Else 
											OBJECT SET VALUE:C1742($tool.formObject; "")
									End case 
									
							End case 
							
						Else 
							
							OBJECT SET ENABLED:C1123(*; $tool.formObject; $enabled)
							
							var $selected : Boolean
							$selected:=Choose:C955($actionState.selected#Null:C1517; $actionState.selected; False:C215)
							
							OBJECT SET VALUE:C1742($tool.formObject; Num:C11($selected))
							
					End case 
					
				End for each 
				
			End if 
			
		End for each 
		
	End if 
	
	
Function _buildForm()->$success : Boolean
	
	var $widget : cs:C1710.ImgWidget
	$widget:=This:C1470.widget
	
	If ($widget.menubar#Null:C1517)
		$widget.menubar.build()
	End if 
	
	If ($widget.toolbar#Null:C1517)
		$widget.toolbar.build()
	End if 
	
	If ($widget.sidebar#Null:C1517)
		$widget.sidebar.build()
	End if 
	
	$success:=True:C214
	
	
Function _applyLayout()->$success : Boolean
	
	var $widget : cs:C1710.ImgWidget
	$widget:=This:C1470.widget
	
	If ($widget.menubar#Null:C1517)
		$widget.menubar.apply()
	End if 
	
	If ($widget.toolbar#Null:C1517)
		$widget.toolbar.apply()
	End if 
	
	If ($widget.sidebar#Null:C1517)
		$widget.sidebar.apply()
	End if 
	
	If ($widget.areaName#Null:C1517)
		This:C1470._postApplyAreaLayout()
	End if 
	
	$success:=True:C214
	
	
	
	
	
Function _handleBootstrap()
	
	var $widget : cs:C1710.ImgWidget
	$widget:=This:C1470.widget
	
	Super:C1706._handleBootstrap()
	
	If ($widget.state.pendingAreaVisibility)
		OB_CallForm($widget; $widget._restoreAreaVisibility)
	End if 
	
	This:C1470._postApplyAreaLayout()
	
	OB_CallForm($widget; $widget._updateState)
	
	
Function _handleMenuEvent($event : Object)
	
	var $widget : cs:C1710.ImgWidget
	$widget:=This:C1470.widget
	
	var $formObject : Text
	$formObject:=$event.objectName
	
	Case of 
		: ($event.code=On Clicked:K2:4)
			
			var $menu : cs:C1710.Menu
			$menu:=This:C1470.widget.menubar.getMenuFromFormObject($formObject)
			
			If ($menu#Null:C1517)
				
				var $popupX; $popupY : Integer
				$popupX:=$menu.bounds.x
				$popupY:=$menu.bounds.y+$menu.bounds.height
				
				var $actionName : Text
				$actionName:=This:C1470._popupActionItemMenu($menu.items; $popupX; $popupY)
				If ($actionName#"")
					OB_CallForm(This:C1470.widget; This:C1470.widget._performAction; New collection:C1472($actionName))
				End if 
				
			End if 
			
		: ($event.code=On Mouse Enter:K2:33)
			
			var $title; $format : Text
			
			$title:=OBJECT Get title:C1068(*; $formObject)
			$format:=$title+$widget.style.menu.hoverFormat
			
			OBJECT SET FORMAT:C236(*; $formObject; $format)
			
		: ($event.code=On Mouse Leave:K2:34)
			
			var $title; $format : Text
			
			$title:=OBJECT Get title:C1068(*; $formObject)
			$format:=$title+$widget.style.menu.normalFormat
			
			OBJECT SET FORMAT:C236(*; $formObject; $format)
			
	End case 
	
	
Function _popupActionItemMenu($items : Collection; \
$popupX : Integer; $popupY : Integer)->$actionName : Text
	
	CONVERT COORDINATES:C1365($popupX; $popupY; XY Current form:K27:5; XY Current window:K27:6)
	
	var $menuRef : Text
	$menuRef:=This:C1470.widget._buildMenu($items)
	
	$actionName:=Dynamic pop up menu:C1006($menuRef; ""; $popupX; $popupY)
	
	RELEASE MENU:C978($menuRef)
	
	
Function _handleToolEvent($event : Object)
	
	var $widget : cs:C1710.ImgWidget
	$widget:=This:C1470.widget
	
	var $tool : cs:C1710.Tool
	$tool:=This:C1470.widget.toolbar.getToolFromFormObject($event.objectName)
	
	If ($tool#Null:C1517)
		
		var $actionName : Text
		$actionName:=""
		
		Case of 
			: ($tool.type="button") | ($tool.type="radio") | ($tool.type="check")
				
				Case of 
					: ($event.code=On Clicked:K2:4)
						
						If ($tool.items#Null:C1517)
							
							var $popupX; $popupY : Integer
							$popupX:=$tool.bounds.x
							$popupY:=$tool.bounds.y+$tool.bounds.height
							
							$actionName:=This:C1470._popupActionItemMenu($tool.items; $popupX; $popupY)
							
						Else 
							$actionName:=$tool.action.name
						End if 
						
						If ($actionName#"")
							
							OB_CallForm($widget; $widget._performAction; New collection:C1472($actionName))
							
						End if 
						
				End case 
				
			: ($tool.type="input")
				
				$actionName:=$tool.action.name
				
				var $actionStatus : Object
				$actionStatus:=$widget.actionStates[$actionName].status
				$actionStatus:=Choose:C955($actionStatus#Null:C1517; $actionStatus; New object:C1471())
				
				var $oldValue : Text
				$oldValue:=Choose:C955($actionStatus.displayValue#Null:C1517; \
					$actionStatus.displayValue; \
					Choose:C955($actionStatus.value#Null:C1517; $actionStatus.value; ""))
				
				Case of 
					: ($event.code=On Getting Focus:K2:7)
						
						Case of 
							: ($tool.input.valueType="integer")
								
								OBJECT SET VALUE:C1742($event.objectName; String:C10($actionStatus.value))
								
								OBJECT SET FILTER:C235(*; $event.objectName; "&\"0;1;2;3;4;5;6;7;8;9\"")
								
							: ($tool.input.valueType="number") | ($tool.input.valueType="percent")
								
								OBJECT SET VALUE:C1742($event.objectName; String:C10($actionStatus.value))
								
								var $sep : Text
								GET SYSTEM FORMAT:C994(Decimal separator:K60:1; $sep)
								
								OBJECT SET FILTER:C235(*; $event.objectName; "&\"0;1;2;3;4;5;6;7;8;9;"+$sep+"\"")
								
						End case 
						
						HIGHLIGHT TEXT:C210(*; $event.objectName; 0; MAXINT:K35:1)
						
					: ($event.code=On Losing Focus:K2:8)
						
						OBJECT SET VALUE:C1742($event.objectName; $oldValue)
						
					: ($event.code=On Data Change:K2:15)
						
						var $textValue : Text
						$textValue:=OBJECT Get value:C1743($event.objectName)
						
						Case of 
							: ($tool.input.valueType="integer")
								
								var $intValue : Integer
								$intValue:=Int:C8(Num:C11($textValue))
								
								var $isValid : Boolean
								$isValid:=True:C214
								
								If ($tool.input.minValue#Null:C1517)
									If ($intValue<$tool.input.minValue)
										$isValid:=False:C215
									End if 
								End if 
								If ($tool.input.maxValue#Null:C1517)
									If ($intValue>$tool.input.maxValue)
										$isValid:=False:C215
									End if 
								End if 
								
								If ($isValid)
									
									var $args : Object
									$args:=New object:C1471()
									
									$args.value:=$intValue
									
									OB_CallForm($widget; $widget._performAction; New collection:C1472($actionName; $args))
									
								End if 
								
							: ($tool.input.valueType="number")
								
							: ($tool.input.valueType="percent")
								
								var $percentValue : Real
								$percentValue:=Num:C11($textValue)
								
								var $isValid : Boolean
								$isValid:=True:C214
								
								If ($tool.input.minValue#Null:C1517)
									If ($percentValue<$tool.input.minValue)
										$isValid:=False:C215
									End if 
								End if 
								If ($tool.input.maxValue#Null:C1517)
									If ($percentValue>$tool.input.maxValue)
										$isValid:=False:C215
									End if 
								End if 
								
								If ($isValid)
									
									var $args : Object
									$args:=New object:C1471()
									
									$args.value:=$percentValue
									
									OB_CallForm($widget; $widget._performAction; New collection:C1472($actionName; $args))
									
								End if 
								
						End case 
						
				End case 
				
		End case 
		
	End if 
	
	
Function _handleThumbsEvent($event : Object)
	
	var $widget : cs:C1710.ImgWidget
	$widget:=This:C1470.widget
	
	If ($widget.sidebar#Null:C1517)
		
		Case of 
			: ($event.code=On Scroll:K2:57)
				
				SET TIMER:C645(1)
				
			: ($event.code=On Selection Change:K2:29)
				
				var $row : Integer
				$row:=$widget.currentThumbnailIndex
				
				var $thumbnailController : cs:C1710.ThumbnailController
				$thumbnailController:=$widget.thumbnailController
				
				If ($thumbnailController.isSetup)
					OB_CallForm($thumbnailController; $thumbnailController.handleThumbnailSelection; New collection:C1472($row))
				End if 
				
		End case 
		
	End if 
	
	
Function _handleTOCEvent($event : Object)
	
	var $widget : cs:C1710.ImgWidget
	$widget:=This:C1470.widget
	
	If ($widget.sidebar#Null:C1517)
		
		Case of 
			: ($event.code=On Selection Change:K2:29)
				
				var $itemRef : Integer
				$itemRef:=Selected list items:C379(*; "sidebar_toc"; *)
				
				var $bookmarkController : cs:C1710.BookmarkController
				$bookmarkController:=$widget.bookmarkController
				
				If ($bookmarkController.isSetup)
					OB_CallForm($bookmarkController; $bookmarkController.handleBookmarkSelection; New collection:C1472($itemRef))
				End if 
				
		End case 
		
	End if 
	
	
Function _handleSplitterEvent($event : Object)->$handled : Boolean
	
	var $widget : cs:C1710.ImgWidget
	$widget:=This:C1470.widget
	
	If ($widget.sidebar#Null:C1517)
		
		If ($widget.sidebar.handleSplitterEvent($event))
			
			var $bounds : cs:C1710.Rect
			$bounds:=$widget.sidebar.bounds
			
			$widget.sidebar.layout($widget.controlWidth; $widget.controlHeight; $bounds.x; $bounds.y)
			$widget.sidebar.apply()
			
			C_OBJECT:C1216($cellSize)
			$cellSize:=$widget.thumbnailController.calcCellSize()
			
			LISTBOX SET COLUMN WIDTH:C833(*; "sidebar_thumbs"; $cellSize.width)
			LISTBOX SET ROWS HEIGHT:C835(*; "sidebar_thumbs"; $cellSize.height; lk pixels:K53:22)
			
			If ($widget.thumbnailController.isSetup)
				
				$widget.thumbnailController._resize()
				
			End if 
			
			If ($widget.areaName#"")
				This:C1470._postApplyAreaLayout()
			End if 
			
		End if 
		
	End if 
	
	
Function _handleTimer()->$done : Boolean
	
	$done:=Super:C1706._handleTimer()
	
	If (This:C1470.widget.thumbnailController.isSetup)
		$done:=$done & This:C1470.widget.thumbnailController.task()
	End if 
	