Class constructor($x : Real; $y : Real; $width : Real; $height : Real)
	
	This:C1470.x:=$x
	This:C1470.y:=$y
	This:C1470.width:=$width
	This:C1470.height:=$height
	
	
Function size()->$size : cs:C1710.Size
	$size:=cs:C1710.Size.new(This:C1470.width; This:C1470.height)
	
	
Function fit($other : cs:C1710.Rect; $center : Boolean; $scaleUp : Boolean)->$fitRect : cs:C1710.Rect
	
	$center:=Choose:C955(Count parameters:C259>1; $center; True:C214)
	$scaleUp:=Choose:C955(Count parameters:C259>2; $scaleUp; False:C215)
	
	var $newSize : cs:C1710.Size
	$newSize:=This:C1470.size().fit($other.size(); $scaleUp)
	
	var $fitRect : cs:C1710.Rect
	$fitRect:=cs:C1710.Rect.new($other.x; $other.y; $newSize.width; $newSize.height)
	
	If ($center)
		$fitRect:=This:C1470.centered($fitRect)
	End if 
	
	
Function fitScale($other : cs:C1710.Rect; $center : Boolean; $cover : Boolean)->$scale : Real
	
	var $scaleH; $scaleV; $bestScale : Real
	$bestScale:=1
	$scaleH:=This:C1470.width/$other.width
	$scaleH:=This:C1470.height/$other.height
	
	If ($cover)
		If ($scaleH<$scaleV)
			$bestScale:=$scaleH
		Else 
			$bestScale:=$scaleV
		End if 
	Else 
		If ($scaleH<$scaleV)
			$bestScale:=$scaleV
		Else 
			$bestScale:=$scaleH
		End if 
	End if 
	
	$scale:=$bestScale
	
	
Function fitSize($otherSize : cs:C1710.Size; $center : Boolean; $cover : Boolean)->$fitRect : cs:C1710.Rect
	
	Case of 
		: (Count parameters:C259=1)
			
			$center:=True:C214
			$cover:=False:C215
			
		: (Count parameters:C259=2)
			
			$cover:=False:C215
			
	End case 
	
	var $scaleH; $scaleV; $bestScale : Real
	$bestScale:=1
	$scaleH:=This:C1470.width/$otherSize.width
	$scaleV:=This:C1470.height/$otherSize.height
	
	If ($cover)
		If ($scaleH<$scaleV)
			$bestScale:=$scaleV
		Else 
			$bestScale:=$scaleH
		End if 
	Else 
		If ($scaleH<$scaleV)
			$bestScale:=$scaleH
		Else 
			$bestScale:=$scaleV
		End if 
	End if 
	
	var $scaledSourceWidth; $scaledSourceHeight : Real
	
	If ($bestScale#1)
		$scaledSourceWidth:=$bestScale*$otherSize.width
		$scaledSourceHeight:=$bestScale*$otherSize.height
	Else 
		$scaledSourceWidth:=$otherSize.width
		$scaledSourceHeight:=$otherSize.height
	End if 
	
	$fitRect:=cs:C1710.Rect.new(\
		This:C1470.x; This:C1470.y; \
		$scaledSourceWidth; $scaledSourceHeight)
	
	If ($center)
		$fitRect:=This:C1470.centered($fitRect)
	End if 
	
	
Function centered($other : cs:C1710.Rect)->$centered : cs:C1710.Rect
	
	C_REAL:C285($centeredRectX; $centeredRectY)
	$centeredRectX:=This:C1470.x+((This:C1470.width-$other.width)/2)
	$centeredRectY:=This:C1470.y+((This:C1470.height-$other.height)/2)
	
	$centered:=cs:C1710.Rect.new($centeredRectX; $centeredRectY; $other.width; $other.height)
	