Class constructor()
	
	This:C1470.svg:=""
	This:C1470.outline:=""
	This:C1470.image:=""
	This:C1470.label:=""
	This:C1470.selection:=""
	
	This:C1470.width:=0
	This:C1470.height:=0
	
	This:C1470.shadedSpace:=Null:C1517
	This:C1470.imageSpace:=Null:C1517
	This:C1470.outlineSpace:=Null:C1517
	This:C1470.labelSpace:=Null:C1517
	This:C1470.selection:=Null:C1517
	This:C1470.svgSource:=""
	
	This:C1470.thumbFormat:="JPEG"
	
	This:C1470.style:=Null:C1517
	
	This:C1470.dummyImageData64:="iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAQAAAC1HAwCAAAAEUlEQVR4nGL4zwAAAAD//wMAAgEBAOS7JXMAAAAASUVORK5CYII="
	
Function _calcLabelHeight($style : Object)->$labelHeight : Integer
	
	$style:=Choose:C955(This:C1470.style#Null:C1517; This:C1470.style; $style)
	
	var $thumbStyle : Object
	$thumbStyle:=$style.thumb
	
	var $textSize : cs:C1710.Size
	$textSize:=_SVG_Measure_Text("9"; \
		$thumbStyle.fontFamily; \
		$thumbStyle.fontSize; \
		$thumbStyle.fontStyle; \
		$thumbStyle.fontWeight; \
		$thumbStyle.textDecoration)
	
	$labelHeight:=$textSize.height
	
	
Function setup($cellWidth : Integer; $cellHeight : Integer; $style : Object)
	
	This:C1470.style:=$style
	
	var $thumbStyle : Object
	$thumbStyle:=This:C1470.style.thumb
	
	var $shadowStyle : Object
	$shadowStyle:=This:C1470.style.thumbShadow
	
	var $selectionStyle : Object
	$selectionStyle:=This:C1470.style.selectedThumb
	
	var $padding : cs:C1710.Size
	$padding:=cs:C1710.Size.new($thumbStyle.paddingX; $thumbStyle.paddingY)
	
	var $textHeight : Integer
	$textHeight:=This:C1470._calcLabelHeight()
	
	// --------------------------------------------
	var $shadedOrigin : cs:C1710.Point
	$shadedOrigin:=cs:C1710.Point.new($padding.width; $padding.height)
	
	var $shadedSize : cs:C1710.Size
	$shadedSize:=cs:C1710.Size.new($cellWidth-($padding.width*2); $cellHeight-($padding.height*2)-$textHeight)
	
	// --------------------------------------------
	var $imgOrigin : cs:C1710.Point
	$imgOrigin:=cs:C1710.Point.new($shadedOrigin.x; $shadedOrigin.y)
	
	var $imgSize : cs:C1710.Size
	$imgSize:=cs:C1710.Size.new($shadedSize.width-$shadowStyle.size.width; $shadedSize.height-$shadowStyle.size.height)
	
	// --------------------------------------------
	var $outlineOrigin : cs:C1710.Point
	$outlineOrigin:=cs:C1710.Point.new($shadedOrigin.x; $shadedOrigin.y)
	
	var $outlineSize : cs:C1710.Size
	$outlineSize:=cs:C1710.Size.new($shadedSize.width; $shadedSize.height)
	
	var $outlineRad : cs:C1710.Size
	$outlineRad:=cs:C1710.Size.new($padding.width*2; $padding.height*2)
	
	// --------------------------------------------
	var $labelOrigin : cs:C1710.Point
	$labelOrigin:=cs:C1710.Point.new($padding.width; $shadedOrigin.y+$shadedSize.height+($padding.height/2))
	
	var $labelSize : cs:C1710.Size
	$labelSize:=cs:C1710.Size.new($cellWidth-($padding.width*2); $textHeight)
	
	// --------------------------------------------
	var $selectionOrigin : cs:C1710.Point
	$selectionOrigin:=cs:C1710.Point.new($padding.width/2; $padding.height/2)
	
	var $selectionSize : cs:C1710.Size
	$selectionSize:=cs:C1710.Size.new($cellWidth-$padding.width; $cellHeight-$padding.height)
	
	// --------------------------------------------
	var $svg; $defs; $filter; $offset; $blur; $blend : Text
	var $outline; $img; $label; $selection : Text
	
	$svg:=DOM Create XML Ref:C861(\
		"svg"; "http://www.w3.org/2000/svg"; \
		"xmlns:xlink"; "http://www.w3.org/1999/xlink")
	
	DOM SET XML ATTRIBUTE:C866($svg; "width"; $cellWidth; "height"; $cellHeight)
	
	$defs:=DOM Create XML element:C865($svg; "defs"; "id"; "defs")
	$filter:=DOM Create XML element:C865($defs; "filter"; "id"; "shadow")
	$offset:=DOM Create XML element:C865($filter; "feOffset"; \
		"result"; "offOut"; \
		"dx"; String:C10($shadowStyle.offset.width; "&xml"); \
		"dy"; String:C10($shadowStyle.offset.height; "&xml"))
	$blur:=DOM Create XML element:C865($filter; "feGaussianBlur"; \
		"in"; "offOut"; \
		"result"; "blurOut"; \
		"stdDeviation"; String:C10($shadowStyle.blur; "&xml"))
	$blend:=DOM Create XML element:C865($filter; "feBlend"; \
		"in"; "SourceGraphic"; \
		"in2"; "blurOut"; \
		"result"; "blurOut"; \
		"mode"; "normal")
	
	$outline:=DOM Create XML element:C865($svg; "rect"; \
		"id"; "outline"; \
		"visibility"; "visible"; \
		"x"; String:C10($outlineOrigin.x; "&xml"); \
		"y"; String:C10($outlineOrigin.y; "&xml"); \
		"width"; String:C10($outlineSize.width; "&xml"); \
		"height"; String:C10($outlineSize.height; "&xml"); \
		"rx"; String:C10($outlineRad.width; "&xml"); "ry"; String:C10($outlineRad.height; "&xml"); \
		"stroke"; $thumbStyle.strokeColor; \
		"fill"; $thumbStyle.fillColor; \
		"stroke-opacity"; String:C10($thumbStyle.strokeOpacity; "&xml"); \
		"fill-opacity"; String:C10($thumbStyle.fillOpacity; "&xml"); \
		"stroke-width"; String:C10($thumbStyle.lineWidth; "&xml"))
	
	$img:=DOM Create XML element:C865($svg; "image"; \
		"id"; "pict"; \
		"visibility"; "visible"; \
		"x"; String:C10($imgOrigin.x; "&xml"); \
		"y"; String:C10($imgOrigin.y; "&xml"); \
		"width"; String:C10($imgSize.width; "&xml"); \
		"height"; String:C10($imgSize.height; "&xml"); \
		"filter"; "url(#shadow)"; \
		"xlink:href"; "data:;base64,"+This:C1470.dummyImageData64)
	
	$label:=DOM Create XML element:C865($svg; "textArea"; \
		"id"; "text"; \
		"visibility"; "visible"; \
		"x"; String:C10($labelOrigin.x; "&xml"); \
		"y"; String:C10($labelOrigin.y; "&xml"); \
		"width"; String:C10($labelSize.width; "&xml"); \
		"height"; String:C10($labelSize.height; "&xml"); \
		"font-family"; $thumbStyle.fontFamily; \
		"font-style"; $thumbStyle.fontStyle; \
		"font-size"; String:C10($thumbStyle.fontSize; "&xml"); \
		"text-align"; $thumbStyle.textAlign; \
		"font-weight"; "normal"; \
		"text-decoration"; "none")
	
	$selection:=DOM Create XML element:C865($svg; "rect"; \
		"id"; "selection"; \
		"visibility"; "visible"; \
		"x"; String:C10($selectionOrigin.x; "&xml"); \
		"y"; String:C10($selectionOrigin.y; "&xml"); \
		"width"; String:C10($selectionSize.width; "&xml"); \
		"height"; String:C10($selectionSize.height; "&xml"); \
		"rx"; String:C10($selectionStyle.lineWidth; "&xml"); \
		"ry"; String:C10($selectionStyle.lineWidth; "&xml"); \
		"stroke"; $selectionStyle.strokeColor; \
		"fill"; $selectionStyle.fillColor; \
		"stroke-opacity"; String:C10($selectionStyle.strokeOpacity; "&xml"); \
		"fill-opacity"; String:C10($selectionStyle.fillOpacity; "&xml"); \
		"stroke-width"; String:C10($selectionStyle.lineWidth; "&xml"))
	
	var $svgSource : Text
	DOM EXPORT TO VAR:C863($svg; $svgSource)
	
	If (This:C1470.svg#"")
		DOM CLOSE XML:C722((This:C1470.svg))
	End if 
	
	This:C1470.svg:=$svg
	This:C1470.outline:=$outline
	This:C1470.image:=$img
	This:C1470.label:=$label
	This:C1470.selection:=$selection
	
	This:C1470.width:=$cellWidth
	This:C1470.height:=$cellHeight
	
	This:C1470.shadedSpace:=cs:C1710.Rect.new(\
		$shadedOrigin.x; $shadedOrigin.y; \
		$shadedSize.width; $shadedSize.height)
	
	This:C1470.imageSpace:=cs:C1710.Rect.new(\
		$imgOrigin.x; $imgOrigin.y; \
		$imgSize.width; $imgSize.height)
	
	This:C1470.outlineSpace:=cs:C1710.Rect.new(\
		$outlineOrigin.x; $outlineOrigin.y; \
		$outlineSize.width; $outlineSize.height)
	
	This:C1470.labelSpace:=cs:C1710.Rect.new(\
		$labelOrigin.x; $labelOrigin.y; \
		$labelSize.width; $labelSize.height)
	
	This:C1470.selectionSpace:=cs:C1710.Rect.new(\
		$selectionOrigin.x; $selectionOrigin.y; \
		$selectionSize.width; $selectionSize.height)
	
	This:C1470.svgSource:=$svgSource
	
	This:C1470.thumbFormat:="JPEG"
	
	
Function cleanup()
	
	If (This:C1470.svg#"")
		DOM CLOSE XML:C722((This:C1470.svg))
	End if 
	
	
Function calcCellHeight($cellWidth : Integer; $style : Object)->$cellHeight : Integer
	
	$cellHeight:=$cellWidth+This:C1470._calcLabelHeight($style)
	
	
Function createGenericThumb($index : Integer; $label : Text; $selected : Boolean)->$thumb : cs:C1710.Thumbnail
	
	var $thumbStyle : Object
	$thumbStyle:=This:C1470.style.thumb
	
	DOM SET XML ATTRIBUTE:C866(This:C1470.image; "visibility"; "hidden")
	DOM SET XML ATTRIBUTE:C866(This:C1470.outline; "visibility"; "visible")
	
	DOM SET XML ATTRIBUTE:C866(This:C1470.outline; \
		"x"; String:C10(This:C1470.outlineSpace.x; "&xml"); \
		"y"; String:C10(This:C1470.outlineSpace.y; "&xml"); \
		"width"; String:C10(This:C1470.outlineSpace.width; "&xml"); \
		"height"; String:C10(This:C1470.outlineSpace.height; "&xml"); \
		"stroke"; $thumbStyle.strokeColor\
		)
	
	DOM SET XML ATTRIBUTE:C866(This:C1470.label; \
		"x"; String:C10(This:C1470.labelSpace.x; "&xml"); \
		"y"; String:C10(This:C1470.labelSpace.y; "&xml"); \
		"width"; String:C10(This:C1470.labelSpace.width; "&xml"); \
		"height"; String:C10(This:C1470.labelSpace.height; "&xml"))
	DOM SET XML ELEMENT VALUE:C868(This:C1470.label; Choose:C955($label#""; $label; String:C10($index)))
	
	DOM SET XML ATTRIBUTE:C866(This:C1470.selection; "visibility"; Choose:C955($selected; "visible"; "hidden"))
	
	If (False:C215)  // Debug
		
		var $svgSource : Text
		DOM EXPORT TO VAR:C863(This:C1470.svg; $svgSource)
		
		var $dumpFile : 4D:C1709.File
		$dumpFile:=Folder:C1567(fk resources folder:K87:11).folder("Q2Pix").folder("Q2ImgControl").folder("Builtins").file("dump.svg")
		File_StoreText($dumpFile; ->$svgSource)
		
		SVGTool_SHOW_IN_VIEWER(This:C1470.svg)
		
	End if 
	
	var $pict : Picture
	SVG EXPORT TO PICTURE:C1017(This:C1470.svg; $pict; Copy XML data source:K45:17/*Get XML data source*/)
	
	$thumb:=cs:C1710.Thumbnail.new($index; $label; $selected; True:C214; $pict)
	
	
Function createErrorThumb($index : Integer; $label : Text; $selected : Boolean)->$thumb : cs:C1710.Thumbnail
	
	var $thumbStyle : Object
	$thumbStyle:=This:C1470.style.thumb
	
	DOM SET XML ATTRIBUTE:C866(This:C1470.image; "visibility"; "hidden")
	DOM SET XML ATTRIBUTE:C866(This:C1470.outline; "visibility"; "visible")
	
	DOM SET XML ATTRIBUTE:C866(This:C1470.outline; \
		"x"; String:C10(This:C1470.outlineSpace.x; "&xml"); \
		"y"; String:C10(This:C1470.outlineSpace.y; "&xml"); \
		"width"; String:C10(This:C1470.outlineSpace.width; "&xml"); \
		"height"; String:C10(This:C1470.outlineSpace.height; "&xml"); \
		"stroke"; "red"\
		)
	
	DOM SET XML ATTRIBUTE:C866(This:C1470.label; \
		"x"; String:C10(This:C1470.labelSpace.x; "&xml"); \
		"y"; String:C10(This:C1470.labelSpace.y; "&xml"); \
		"width"; String:C10(This:C1470.labelSpace.width; "&xml"); \
		"height"; String:C10(This:C1470.labelSpace.height; "&xml"))
	DOM SET XML ELEMENT VALUE:C868(This:C1470.label; Choose:C955($label#""; $label; String:C10($index)))
	
	DOM SET XML ATTRIBUTE:C866(This:C1470.selection; "visibility"; Choose:C955($selected; "visible"; "hidden"))
	
	If (False:C215)
		
		var $svgSource : Text
		DOM EXPORT TO VAR:C863(This:C1470.svg; $svgSource)
		
		var $dumpFile : 4D:C1709.File
		$dumpFile:=Folder:C1567(fk resources folder:K87:11).folder("Q2Pix").folder("Q2ImgControl").folder("Builtins").file("dump.svg")
		File_StoreText($dumpFile; ->$svgSource)
		
		SVGTool_SHOW_IN_VIEWER(This:C1470.svg)
		
	End if 
	
	var $pict : Picture
	SVG EXPORT TO PICTURE:C1017(This:C1470.svg; $pict; Copy XML data source:K45:17/*Get XML data source*/)
	
	$thumb:=cs:C1710.Thumbnail.new($index; $label; $selected; False:C215; $pict)
	
	
	
Function createThumb($index : Integer; $label : Text; $selected : Boolean; \
$pictData : Blob; $pictSize : cs:C1710.Size)->$thumb : cs:C1710.Thumbnail
	
	var $pictWidth; $pictHeight : Integer
	$pictWidth:=$pictSize.width
	$pictHeight:=$pictSize.height
	
	If ($pictWidth>0) & ($pictHeight>0)
		
		var $encodedData : Text
		BASE64 ENCODE:C895($pictData; $encodedData)
		
		If ($encodedData#"")
			
			
			var $thumbStyle : Object
			$thumbStyle:=This:C1470.style.thumb
			
			var $shadowStyle : Object
			$shadowStyle:=This:C1470.style.thumbShadow
			
			var $padding : cs:C1710.Size
			$padding:=cs:C1710.Size.new($thumbStyle.paddingX; $thumbStyle.paddingY)
			
			var $imgSpace; $labelSpace : cs:C1710.Rect
			$imgSpace:=This:C1470.imageSpace
			$labelSpace:=This:C1470.labelSpace
			
			var $totalSpace : cs:C1710.Rect
			$totalSpace:=cs:C1710.Rect.new($padding.width; $padding.height; \
				This:C1470.width-(2*$padding.width); This:C1470.height-(2*$padding.height))
			
			var $pictBounds : cs:C1710.Rect
			$pictBounds:=cs:C1710.Rect.new(0; 0; $pictWidth; $pictHeight)
			
			$pictBounds:=$imgSpace.fit($pictBounds; False:C215)
			
			var $shadeBounds : cs:C1710.Rect
			$shadeBounds:=cs:C1710.Rect.new(0; 0; \
				$pictBounds.width+$shadowStyle.size.width; $pictBounds.height+$shadowStyle.size.height)
			
			var $labelExtraHeight : Real
			$labelExtraHeight:=($padding.height/2)+$labelSpace.height
			
			var $comboBounds : cs:C1710.Rect
			$comboBounds:=cs:C1710.Rect.new(0; 0; $shadeBounds.width; $shadeBounds.height+$labelExtraHeight)
			
			$comboBounds:=$totalSpace.fit($comboBounds; True:C214)
			
			var $imgRect : cs:C1710.Rect
			$imgRect:=cs:C1710.Rect.new($comboBounds.x; $comboBounds.y; $pictBounds.width; $pictBounds.height)
			
			var $shadeRect : cs:C1710.Rect
			$shadeRect:=cs:C1710.Rect.new($imgRect.x; $imgRect.y; $shadeBounds.width; $shadeBounds.height)
			
			var $labelRect : cs:C1710.Rect
			$labelRect:=cs:C1710.Rect.new($labelSpace.x; \
				$imgRect.y+$shadeBounds.height+($padding.height/2); \
				$labelSpace.width; $labelSpace.height)
			
			DOM SET XML ATTRIBUTE:C866(This:C1470.image; "visibility"; "visible")
			DOM SET XML ATTRIBUTE:C866(This:C1470.outline; "visibility"; "hidden")
			
			DOM SET XML ATTRIBUTE:C866(This:C1470.image; \
				"x"; String:C10($imgRect.x; "&xml"); \
				"y"; String:C10($imgRect.y; "&xml"); \
				"width"; String:C10($imgRect.width; "&xml"); \
				"height"; String:C10($imgRect.height; "&xml"); \
				"xlink:href"; "data:;base64,"+$encodedData)
			
			DOM SET XML ATTRIBUTE:C866(This:C1470.label; \
				"x"; String:C10($labelRect.x; "&xml"); \
				"y"; String:C10($labelRect.y; "&xml"); \
				"width"; String:C10($labelRect.width; "&xml"); \
				"height"; String:C10($labelRect.height; "&xml"))
			DOM SET XML ELEMENT VALUE:C868(This:C1470.label; Choose:C955($label#""; $label; String:C10($index)))
			
			DOM SET XML ATTRIBUTE:C866(This:C1470.selection; "visibility"; Choose:C955($selected; "visible"; "hidden"))
			
			If (False:C215)  // Debug
				
				var $svgSource : Text
				DOM EXPORT TO VAR:C863(This:C1470.svg; $svgSource)
				
				//var $dumpFile : 4D.File
				//$dumpFile:=Folder(fk resources folder).folder("Q2Pix").folder("Q2ImgControl").folder("Builtins").file("dump.svg")
				//File_StoreText($dumpFile; ->$svgSource)
				
				SVGTool_SHOW_IN_VIEWER(This:C1470.svg)
				
			End if 
			
			var $pict : Picture
			SVG EXPORT TO PICTURE:C1017(This:C1470.svg; $pict; Copy XML data source:K45:17/*Get XML data source*/)
			
			$thumb:=cs:C1710.Thumbnail.new($index; $label; $selected; False:C215; $pict; $encodedData; $pictSize)
			
		End if 
		
	End if 
	
	
Function _encodedPictData($pict : Picture)->$encodedData : Text
	
	var $pictData : Blob
	
	ARRAY TEXT:C222($formats; 0)
	PictUtil_GetImageFormats:P11667:123($pict; $formats)
	
	var $idx : Integer
	$idx:=Find in array:C230($formats; "JPEG")
	If ($idx<=0)
		$idx:=Find in array:C230($formats; "PNG")
	End if 
	
	If ($idx>0)
		$pictData:=PictUtil_GetImageData:P11667:124($pict; $idx)
	End if 
	
	If (BLOB size:C605($pictData)=0)
		PICTURE TO BLOB:C692($pict; $pictData; This:C1470.thumbFormat)
	End if 
	
	If (BLOB size:C605($pictData)>0)
		BASE64 ENCODE:C895($pictData; $encodedData)
	End if 
	
	
Function maxPictSize()->$maxSize : cs:C1710.Size
	
	If (This:C1470.imageSpace#Null:C1517)
		$maxSize:=cs:C1710.Size.new(This:C1470.imageSpace.width; This:C1470.imageSpace.height)
	Else 
		$maxSize:=cs:C1710.Size.new(0; 0)
	End if 
	
	