// =====================================
// Public API

Class constructor($controlName : Text)
	
	This:C1470.sourceConfig:=Null:C1517
	
	This:C1470.controlName:=""
	This:C1470.windowRef:=Current form window:C827
	This:C1470.formName:=Current form name:C1298
	This:C1470.processID:=Process_GetID()
	
	This:C1470.initiallyVisible:=False:C215
	This:C1470.formPage:=-1
	
	This:C1470.formStorageKey:="controlPages#"+String:C10(This:C1470.windowRef)+"#"+String:C10(This:C1470.processID)
	This:C1470.formStorage:=Null:C1517
	
	This:C1470.state:=New object:C1471()
	This:C1470.state.controlsBuilt:=False:C215
	This:C1470.state.layoutBuilt:=False:C215
	This:C1470.state.formBuilt:=False:C215
	This:C1470.state.layoutApplied:=False:C215
	This:C1470.state.pendingVisibility:=False:C215
	
	This:C1470.bounds:=Null:C1517
	This:C1470.controlWidth:=0
	This:C1470.controlHeight:=0
	
	This:C1470.config:=Null:C1517
	
	This:C1470.innerWidget:=Null:C1517
	
	var $controlPtr : Pointer
	$controlPtr:=OBJECT Get pointer:C1124(Object named:K67:5; $controlName)
	
	If (Not:C34(Is nil pointer:C315($controlPtr)))
		
		This:C1470.controlName:=$controlName
		This:C1470.initiallyVisible:=OBJECT Get visible:C1075(*; $controlName)
		This:C1470.visible:=This:C1470.initiallyVisible
		
		OBJECT SET VISIBLE:C603(*; This:C1470.controlName; False:C215)
		This:C1470.state.pendingVisibility:=True:C214
		
		This:C1470.formStorage:=This:C1470._registerInFormStoreage()
		This:C1470.formPage:=This:C1470.formStorage.controlPages[$controlName]
		
		var $left; $top; $right; $bottom : Integer
		OBJECT GET COORDINATES:C663(*; This:C1470.controlName; $left; $top; $right; $bottom)
		//This.bounds:=cs.Rect.new($left; $top; $right-$left; $bottom-$top)
		This:C1470.controlWidth:=$right-$left
		This:C1470.controlHeight:=$bottom-$top
		
		This:C1470.innerWidget:=cs:C1710.InnerWidget.new(This:C1470)
		
		OBJECT SET VALUE:C1742(This:C1470.controlName; This:C1470)
		
	End if 
	
	
Function cleanup()
	
	This:C1470._unregisterFromFormStorage()
	
	
Function setup($config : Variant)->$success : Boolean
	
	This:C1470.config:=$config
	
	This:C1470.state.controlsBuilt:=This:C1470._buildControls()
	This:C1470.state.layoutBuilt:=This:C1470._buildLayout()
	
	If (This:C1470.onCurrentPage())
		
		This:C1470.state.formBuilt:=This:C1470.buildForm()
		This:C1470.state.layoutApplied:=This:C1470.applyLayout()
		
		If (This:C1470.state.pendingVisibility)
			OB_CallForm(This:C1470; This:C1470._restoreVisibility)
		End if 
		
	Else 
		
		This:C1470.state.formBuilt:=False:C215
		This:C1470.state.layoutApplied:=False:C215
		
	End if 
	
	$success:=True:C214
	
	
Function _updateState()
	
	
Function resize()
	
	var $left; $top; $right; $bottom : Integer
	OBJECT GET COORDINATES:C663(*; This:C1470.controlName; $left; $top; $right; $bottom)
	This:C1470.controlWidth:=$right-$left
	This:C1470.controlHeight:=$bottom-$top
	
	This:C1470.state.layoutBuilt:=This:C1470._buildLayout()
	If (This:C1470.onCurrentPage())
		This:C1470.state.layoutApplied:=This:C1470.applyLayout()
	Else 
		This:C1470.state.layoutApplied:=False:C215
	End if 
	
	
	// ====================================+++=
	// Internal stuff
	
Function _registerInFormStoreage()->$formStorage : Object
	
	This:C1470._checkFormStorage()
	
	$formStorage:=Storage:C1525[This:C1470.formStorageKey]
	
	Use ($formStorage.widgets)
		$formStorage.widgets.push(This:C1470.controlName)
	End use 
	
	
Function _unregisterFromFormStorage()
	
	var $formStorage : Object
	$formStorage:=Storage:C1525[This:C1470.formStorageKey]
	
	Use ($formStorage.widgets)
		
		var $idx : Integer
		$idx:=$formStorage.widgets.indexOf(This:C1470.controlName)
		If ($idx>=0)
			$formStorage.widgets.remove($idx)
		End if 
		
	End use 
	
	If ($formStorage.widgets.length=0)
		Use (Storage:C1525)
			OB REMOVE:C1226(Storage:C1525; This:C1470.formStorageKey)
		End use 
	End if 
	
	
Function _checkFormStorage()
	
	If (Storage:C1525[This:C1470.formStorageKey]=Null:C1517)
		
		var $formData : Object
		$formData:=New shared object:C1526()
		
		ARRAY TEXT:C222($controlNames; 0)
		ARRAY POINTER:C280($controlVars; 0)
		ARRAY LONGINT:C221($controlPages; 0)
		
		FORM GET OBJECTS:C898($controlNames; $controlVars; $controlPages)
		
		Use ($formData)
			
			$formData.controlPages:=New shared object:C1526()
			$formData.widgets:=New shared collection:C1527()
			
			Use ($formData.controlPages)
				
				var $idx : Integer
				For ($idx; 1; Size of array:C274($controlNames))
					$formData.controlPages[$controlNames{$idx}]:=$controlPages{$idx}
				End for 
			End use 
			
		End use 
		
		Use (Storage:C1525)
			
			Storage:C1525[This:C1470.formStorageKey]:=$formData
			
		End use 
		
	End if 
	
	
	
Function _restoreVisibility()
	If (This:C1470.state.pendingVisibility)
		OBJECT SET VISIBLE:C603(*; This:C1470.controlName; This:C1470.initiallyVisible)
		This:C1470.state.pendingVisibility:=False:C215
	End if 
	
	
Function isVisible()->$visible : Boolean
	
	$visible:=This:C1470.visible
	
	
Function setVisible($visible : Boolean)
	If (This:C1470.pendingVisibility)
		This:C1470.initiallyVisible:=$visible
		This:C1470.visible:=$visible
	Else 
		This:C1470.visible:=$visible
		OBJECT SET VISIBLE:C603(*; This:C1470.controlName; This:C1470.visible)
	End if 
	
	
Function onCurrentPage()->$onPage : Boolean
	
	$onPage:=(This:C1470.formPage=0) | (This:C1470.formPage=FORM Get current page:C276())
	
	
	// ====================================+++=
	// Builders
	
Function _buildControls()->$success : Boolean
	
	$success:=True:C214
	
	
Function _buildLayout()->$success : Boolean
	
	$success:=True:C214
	
	
Function buildForm()->$success : Boolean
	
	$success:=OB_ExecuteInSubform(This:C1470.controlName; This:C1470.innerWidget; This:C1470.innerWidget._buildForm)
	
	
Function applyLayout()->$success : Boolean
	
	$success:=OB_ExecuteInSubform(This:C1470.controlName; This:C1470.innerWidget; This:C1470.innerWidget._applyLayout)
	
	
	