//%attributes = {"invisible":true,"shared":true}
C_TEXT:C284($1;$message)
C_TEXT:C284($2;$command)
C_OBJECT:C1216($3;$env)
C_OBJECT:C1216($0;$status)

$message:=$1
$command:=$2
$env:=$3

C_OBJECT:C1216($context)
$context:=$env.context

C_LONGINT:C283($areaRef)
$areaRef:=$env.areaRef

C_TEXT:C284($docRef;$docFormat)
$docRef:=$env.docRef
$docFormat:=$env.docFormat

C_LONGINT:C283($frameIdx;$frameCount)
$frameIdx:=$env.frameIndex
$frameCount:=$env.frameCount

$status:=New object:C1471
$status.enabled:=False:C215

If ($docRef#"")
	
	C_OBJECT:C1216($zoomFactorRange)
	ImgArea_GetProperty ($areaRef;"ZoomFactorRange";->$zoomFactorRange)
	
	C_REAL:C285($zoomFactorMin;$zoomFactorMax)
	$zoomFactorMin:=OB Get:C1224($zoomFactorRange;"Minimum";Is real:K8:4)
	$zoomFactorMax:=OB Get:C1224($zoomFactorRange;"Maximum";Is real:K8:4)
	
	C_REAL:C285($zoomToolRate)
	ImgArea_GetProperty ($areaRef;"ZoomToolRate";->$zoomToolRate)
	
	C_REAL:C285($zoomFactor)
	$zoomFactor:=ImgArea_GetZoomFactor:P11667:44 ($areaRef)
	
	C_LONGINT:C283($autoZoom)
	$autoZoom:=ImgArea_GetAutoZoom:P11667:54 ($areaRef)
	
	Case of 
		: ($message="status")
			
			Case of 
				: ($command="img_zoom_in")
					
					$status.enabled:=($zoomFactor<$zoomFactorMax)
					
				: ($command="img_zoom_out")
					
					$status.enabled:=($zoomFactor>$zoomFactorMin)
					
				: ($command="img_zoom_100")
					
					$status.enabled:=True:C214
					
				: ($command="img_zoom_fit")
					
					$status.enabled:=True:C214
					If ($autoZoom#0)
						$status.checked:=True:C214
					End if 
					
				: ($command="img_zoom_percent")
					
					$status.enabled:=True:C214
					$status.value:=$zoomFactor*100
					$status.minValue:=$zoomFactorMin*100
					$status.maxValue:=$zoomFactorMax*100
					
					C_TEXT:C284($decSep)
					GET SYSTEM FORMAT:C994(Decimal separator:K60:1;$decSep)
					
					C_TEXT:C284($displayValue)
					$displayValue:=String:C10($status.value;"###0.0")
					If (($displayValue="@.0") | ($displayValue=("@"+$decSep+"0")))
						$displayValue:=Substring:C12($displayValue;1;Length:C16($displayValue)-2)
					End if 
					
					$status.displayValue:=$displayValue+"%"
					
			End case 
			
		: ($message="action")
			
			Case of 
				: ($command="img_zoom_in")
					
					$zoomFactor:=$zoomFactor*$zoomToolRate
					$zoomFactor:=Real_LimitToMinMax ($zoomFactor;$zoomFactorMin;$zoomFactorMax)
					
					ImgArea_SetZoomFactor:P11667:45 ($areaRef;$zoomFactor)
					
				: ($command="img_zoom_out")
					
					$zoomFactor:=$zoomFactor/$zoomToolRate
					$zoomFactor:=Real_LimitToMinMax ($zoomFactor;$zoomFactorMin;$zoomFactorMax)
					
					ImgArea_SetZoomFactor:P11667:45 ($areaRef;$zoomFactor)
					
				: ($command="img_zoom_100")
					
					ImgArea_SetZoomFactor:P11667:45 ($areaRef;1)
					
				: ($command="img_zoom_fit")
					
					ImgArea_SetAutoZoom:P11667:55 ($areaRef;kImgAreaAutoZoomToFit | kImgAreaAutoZoomStretch | kImgAreaAutoZoomSticky)
					
				: ($command="img_zoom_percent")
					
					If ($env.value#Null:C1517)
						
						C_REAL:C285($targetZoom)
						$targetZoom:=Num:C11($env.value)/100
						
						If (($targetZoom>=$zoomFactorMin) & ($targetZoom<=$zoomFactorMax))
							ImgArea_SetZoomFactor:P11667:45 ($areaRef;$targetZoom)
						End if 
						
					End if 
					
			End case 
			
	End case 
	
End if 

$0:=$status
