//%attributes = {"invisible":true,"shared":true}
C_OBJECT:C1216($1; $context)
C_TEXT:C284($2; $op)
C_TEXT:C284($3; $command)
C_OBJECT:C1216($4; $args)
C_LONGINT:C283($0; $cmdStatus)

$context:=$1
$op:=$2
$command:=$3
If (Count parameters:C259>3)
	$args:=$4
End if 

$cmdStatus:=0

C_LONGINT:C283($areaRef)
$areaRef:=OB Get:C1224($context; "_area_ref"; Is longint:K8:6)

C_TEXT:C284($docRef)
$docRef:=ImgArea_GetDocument:P11667:41($areaRef)

If ($docRef#"")
	
	C_TEXT:C284($docFormat)
	$docFormat:=ImgDoc_GetFormat:P11667:9($docRef)
	
	C_TEXT:C284($filePath)
	$filePath:=ImgDoc_GetFilePath($docRef)
	
	Case of 
		: ($op="status")
			
			If ($command="img_save_as")
				
				$cmdStatus:=0x0001
				
			Else 
				
				C_BOOLEAN:C305($needsSaving)
				
				If ($filePath#"")  // File-backed
					
					C_LONGINT:C283($docMods)
					$docMods:=ImgDoc_GetEditsSummary:P11667:14($docRef)
					
					$needsSaving:=($docMods#0)
					
				Else   // BLOB-backed or new
					
					C_LONGINT:C283($dataSize)
					$dataSize:=ImgDoc_GetDataSize($docRef)
					
					If ($dataSize>0)  // BLOB-backed
						$needsSaving:=True:C214
					Else 
						C_LONGINT:C283($frameCount)
						$frameCount:=ImgDoc_GetFrameCount:P11667:11($docRef)
						$needsSaving:=($frameCount>0)
					End if 
					
				End if 
				
				$cmdStatus:=0x0001*Num:C11($needsSaving)
				
			End if 
			
		: ($op="run")
			
			C_OBJECT:C1216($docFormatInfo)
			$docFormatInfo:=ImgFormat_GetInfo($docFormat)
			
			C_BOOLEAN:C305($promptSavingOptions; $promptDestFile)
			$promptSavingOptions:=True:C214
			$promptDestFile:=True:C214
			
			C_OBJECT:C1216($savingOptions)
			C_TEXT:C284($destPOSIXPath)
			
			If ($filePath#"")  // File-backed
				
				If ($command="img_save_as")
					
					$promptDestFile:=True:C214
					$promptSavingOptions:=True:C214
					
					If (OB Is defined:C1231($context; "_saving_options"))
						
						C_OBJECT:C1216($storedOptions)
						$storedOptions:=OB Get:C1224($context; "_saving_options"; Is object:K8:27)
						$savingOptions:=OB Copy:C1225($storedOptions)
						
					Else 
						OB SET:C1220($savingOptions; "Format"; $docFormat)
					End if 
					
				Else 
					
					C_BOOLEAN:C305($docFormatCanEncode)
					$docFormatCanEncode:=OB Get:C1224($docFormatInfo; "CanEncode"; Is boolean:K8:9)
					If ($docFormatCanEncode)
						
						If (OB Is defined:C1231($context; "_saving_options"))
							
							C_OBJECT:C1216($storedOptions)
							$storedOptions:=OB Get:C1224($context; "_saving_options"; Is object:K8:27)
							$savingOptions:=OB Copy:C1225($storedOptions)
							$promptSavingOptions:=False:C215
							
						Else 
							OB SET:C1220($savingOptions; "Format"; $docFormat)
							// FIXME: should display saving options constrained
							// to the doc format, if the format supports settings
							$promptSavingOptions:=False:C215
						End if 
						
						$promptDestFile:=False:C215
						$destPOSIXPath:=$filePath
						
					Else 
						OB SET:C1220($savingOptions; "Format"; $docFormat)
						$promptSavingOptions:=True:C214
						$promptDestFile:=True:C214
					End if 
					
				End if 
				
			Else 
				OB SET:C1220($savingOptions; "Format"; "TIFF")
				$promptSavingOptions:=True:C214
				$promptDestFile:=True:C214
			End if 
			
			C_BOOLEAN:C305($continue)
			$continue:=True:C214
			If ($promptSavingOptions)
				$continue:=(ImgDlog_SavingOptions($docRef; ->$savingOptions)=1)
			End if 
			
			If ($continue & $promptDestFile)
				
				C_TEXT:C284($destFormat)
				
				$destFormat:=OB Get:C1224($savingOptions; "Format"; Is text:K8:3)
				
				C_OBJECT:C1216($destFormatInfo)
				$destFormatInfo:=ImgFormat_GetInfo($destFormat)
				
				ARRAY TEXT:C222($destFormatExtensions; 0)
				OB GET ARRAY:C1229($destFormatInfo; "Extensions"; $destFormatExtensions)
				
				C_TEXT:C284($destExtension)
				$destExtension:=$destFormatExtensions{1}
				
				//C_TEXT($defaultName)
				//If ($filePath#"")
				//C_OBJECT($docFileRef; $defaultFileRef)
				//$docFileRef:=FSRef_InitWithPOSIXPath($filePath)
				//$defaultFileRef:=FSRef_SetExtension($docFileRef; $destExtension)
				//$defaultName:=FSRef_GetSystemPath($defaultFileRef)
				//Else 
				//$defaultName:="Image."+$destExtension
				//End if 
				
				var $filePath : Text
				$filePath:=ImgDoc_GetFilePath($docRef)
				
				var $defaultName : Text
				
				If ($filePath#"")
					
					var $fileObject : 4D:C1709.File
					$fileObject:=File:C1566($filePath; fk posix path:K87:1)
					
					$defaultName:=$fileObject.name
					
				Else 
					$defaultName:="Image"
				End if 
				
				
				ARRAY TEXT:C222($selectedFilePaths; 0)
				C_TEXT:C284($selectedFileName)
				
				$selectedFileName:=Select document:C905($defaultName; "."+$destExtension; "Save image"; File name entry:K24:17; $selectedFilePaths)
				If ($selectedFileName#"")
					
					$destPOSIXPath:=Convert path system to POSIX:C1106($selectedFilePaths{1})
					$continue:=True:C214
					
				Else 
					$continue:=False:C215
				End if 
				
			End if 
			
			If ($continue & ($destPOSIXPath#""))
				
				If (ImgDoc_SaveInFile($docRef; $destPOSIXPath; $savingOptions)=1)
					
					OB SET:C1220($context; "_saving_options"; $savingOptions)
					
					C_OBJECT:C1216($message)
					OB SET:C1220($message; "what"; "ImageSaved")
					Queue_PostMessage_S($context; $message)
					
				End if 
				
			End if 
			
	End case 
	
	ImgObj_Release:P11667:133($docRef)
End if 

$0:=$cmdStatus
