//%attributes = {"shared":true}
C_TEXT:C284($1;$controlName)  // @param: The name of the ``ImgControl`` form object.
C_TEXT:C284($2;$toolsetName)  // @param: The name of the toolset.
C_BOOLEAN:C305($0;$isVisible)  // @param: The toolset's visibility.

  // @desc: Return the visibility of a toolset.

  // @doc: Return the visibility of toolset named ``toolsetName`` of the
  // ``ImgControl`` named ``controlName``.
  //
  // The toolset's visibility is returned in ``isVisible``.
  //

ASSERT:C1129(Count parameters:C259=2)

$controlName:=$1
$toolsetName:=$2
$isVisible:=False:C215

C_POINTER:C301($controlPtr)
$controlPtr:=OBJECT Get pointer:C1124(Object named:K67:5;$controlName)

ASSERT:C1129(Not:C34(Is nil pointer:C315($controlPtr)))
ASSERT:C1129(Type:C295($controlPtr->)=Is object:K8:27)

C_OBJECT:C1216($context)
$context:=$controlPtr->
If ($context#Null:C1517)
	$isVisible:=ImgCtlCtx_IsToolsetVisible ($context;$toolsetName)
End if 

$0:=$isVisible
