//%attributes = {"shared":true}
C_TEXT:C284($1;$controlName)  // @param: The name of the ``ImgControl`` form object.
C_TEXT:C284($2;$toolsetName)  // @param: The name of the toolset.
C_BOOLEAN:C305($3;$visible)  // @param: The toolset's visibility.

  // @desc: Set the visibility of a toolset.

  // @doc: Set the visibility of toolset named ``toolsetName`` of the
  // ``ImgControl`` named ``controlName``.
  //
  // The toolset's visibility is specified in ``isVisible``.
  //

ASSERT:C1129(Count parameters:C259=3)

$controlName:=$1
$toolsetName:=$2
$visible:=$3

C_POINTER:C301($controlPtr)
$controlPtr:=OBJECT Get pointer:C1124(Object named:K67:5;$controlName)

ASSERT:C1129(Not:C34(Is nil pointer:C315($controlPtr)))
ASSERT:C1129(Type:C295($controlPtr->)=Is object:K8:27)

C_OBJECT:C1216($context)
$context:=$controlPtr->
If ($context#Null:C1517)
	
	If ($context.config#Null:C1517)
		
		C_COLLECTION:C1488($foundToolsets)
		$foundToolsets:=$context.config.toolbar.toolsets.query("name = :1";$toolsetName)
		If ($foundToolsets.length>0)
			
			C_OBJECT:C1216($toolset)
			$toolset:=$foundToolsets[0]
			
			$toolset.visible:=$visible
			
			
			
			C_LONGINT:C283($left;$top;$right;$bottom)
			OBJECT GET COORDINATES:C663(*;$context.controlName;$left;$top;$right;$bottom)
			
			C_LONGINT:C283($controlWidth;$controlHeight)
			$controlWidth:=$right-$left
			$controlHeight:=$bottom-$top
			
			ImgCtlNG_UpdateLayout ($context.config;$context.layout;$context.metrics;$controlWidth;$controlHeight)
			$context.state.layoutUpdated:=True:C214
			
			If ((FORM Get current page:C276=$context.formPage) | ($context.formPage=0))
				
				Case of 
					: (True:C214)
						
						$context.form:=ImgCtlNG_BuildForm ($context.config;$context.metrics;$context.layout;$controlWidth;$controlHeight)
						
						C_OBJECT:C1216($subForm)
						$subForm:=$context.form
						
						OBJECT SET SUBFORM:C1138(*;$controlName;$subForm)
						
						$context.state.formSet:=True:C214
						
					Else 
						
						  //C_BOOLEAN($applied)
						  //EXECUTE METHOD IN SUBFORM($controlName;"ImgCtlNG_ApplyLayout";$applied;$context.layout;$context.config;$context.metrics)
						  //$context.state.layoutApplied:=$applied
						
				End case 
				
			Else 
				$context.state.layoutApplied:=False:C215
			End if 
			
			ImgCtlNG_ApplyLayout_PlugArea ($context)
			
		End if 
		
	End if 
	
End if 
