//%attributes = {"shared":true}
C_TEXT:C284($1;$controlName)  // @param: The name of the ``ImgControl`` form object.
C_TEXT:C284($0;$imgDocRef)  // @param: The image document reference.

  // @desc: Return the image document currently assigned to a ImgControl form object.

  // @doc: Return the image document currently assigned to the ``ImgControl`` form object named ``controlName``.
  //
  // The image document reference is returned in ``imgDocRef``. If no document
  // is currently assigned to the area, an empty string is returned.
  //
  // .. note:: Important: this method returns a retained document reference which means
  //           that the caller must release the document when no longer needed with a call
  //           to :cc4d:xmethod:`ImgObj_Release`. Otherwise, there will be a memory leak.
  //


ASSERT:C1129(Count parameters:C259=1)

$controlName:=$1
$imgDocRef:=""

C_OBJECT:C1216($context)
$context:=Control_GetObjectContext ($controlName)
If (OB Is defined:C1231($context))
	
	C_LONGINT:C283($areaRef)
	$areaRef:=OB Get:C1224($context;"_area_ref";Is longint:K8:6)
	
	$imgDocRef:=ImgArea_GetDocument:P11667:41 ($areaRef)
	
End if 

$0:=$imgDocRef
