//%attributes = {"shared":true}
C_TEXT:C284($1;$controlName)  // @param: The name of the ``ImgControl`` form object.
C_TEXT:C284($2;$toolsetName)  // @param: The name of the toolset.
C_BOOLEAN:C305($0;$isVisible)  // @param: The toolset's visibility.

  // @desc: Return the visibility of a toolset.

  // @doc: Return the visibility of toolset named ``toolsetName`` of the
  // ``ImgControl`` named ``controlName``.
  //
  // The toolset's visibility is returned in ``isVisible``.
  //

ASSERT:C1129(Count parameters:C259=2)

$controlName:=$1
$toolsetName:=$2

C_OBJECT:C1216($context)
$context:=Control_GetObjectContext ($controlName)
If (OB Is defined:C1231($context))
	
	C_OBJECT:C1216($toolsetSpec)
	$toolsetSpec:=Control_GetToolsetSpec ($context;$toolsetName)
	
	$isVisible:=OB Get:C1224($toolsetSpec;"_visible";Is boolean:K8:9)
	
End if 

$0:=$isVisible
