//%attributes = {"shared":true}
C_TEXT:C284($1;$controlName)  // @param: The name of the ``ImgControl`` form object.
C_POINTER:C301($2;$imageBLOBPtr)  // @param: Pointer to the BLOB image.
C_LONGINT:C283($0;$success)  // @param: Completion status: ``1`` on success, ``0`` otherwise.

  // @desc: Assign a BLOB containing image data to an ImgControl form object.

  // @doc: Assign a BLOB containing image data to the ``ImgControl`` form object named ``controlName``.
  //
  // Parameter ``imageBLOBPtr`` a pointer to the BLOB containing the image data.

ASSERT:C1129(Count parameters:C259=2)

$controlName:=$1
$imageBLOBPtr:=$2
$success:=0

ASSERT:C1129(Not:C34(Is nil pointer:C315($imageBLOBPtr)))
ASSERT:C1129(Type:C295($imageBLOBPtr->)=Is BLOB:K8:12)

C_OBJECT:C1216($context)
$context:=Control_GetObjectContext ($controlName)
If (OB Is defined:C1231($context))
	
	C_TEXT:C284($imgDocRef)
	$imgDocRef:=ImgDoc_CreateWithBLOB ($imageBLOBPtr)
	If ($imgDocRef#"")
		
		$success:=ImgControl_SetDocument ($controlName;$imgDocRef)
		
		ImgObj_Release:P11667:133 ($imgDocRef)
		
	End if 
	
End if 

$0:=$success
