//%attributes = {"shared":true}
C_TEXT:C284($1;$controlName)  // @param: The name of the ``ImgControl`` form object.
C_TEXT:C284($2;$toolsetName)  // @param: The name of the toolset.
C_BOOLEAN:C305($3;$visible)  // @param: The toolset's visibility.

  // @desc: Set the visibility of a toolset.

  // @doc: Set the visibility of toolset named ``toolsetName`` of the
  // ``ImgControl`` named ``controlName``.
  //
  // The toolset's visibility is specified in ``isVisible``.
  //

ASSERT:C1129(Count parameters:C259=3)

$controlName:=$1
$toolsetName:=$2
$visible:=$3

C_OBJECT:C1216($context)
$context:=Control_GetObjectContext ($controlName)
If (OB Is defined:C1231($context))
	
	C_BOOLEAN:C305($didChange)
	$didChange:=False:C215
	
	C_OBJECT:C1216($toolsetSpec)
	$toolsetSpec:=Control_GetToolsetSpec ($context;$toolsetName)
	If (OB Is defined:C1231($toolsetSpec))
		If (OB Get:C1224($toolsetSpec;"_visible";Is boolean:K8:9)#$visible)
			OB SET:C1220($toolsetSpec;"_visible";$visible)
			$didChange:=True:C214
		End if 
	End if 
	
	If ($didChange)
		ImgControl_UpdateLayout ($controlName)
	End if 
	
End if 
