//%attributes = {"shared":true}
C_TEXT:C284($1;$controlName)  // @param: The name of the ``ImgControl`` form object.

  // @desc: Update the layout of a ImgControl form object.

  // @doc: Update the layout of the ``ImgControl`` form object named ``controlName``.
  //
  // If the ``ImgControl`` object has any of its resizing options set to either *grow* or *move*,
  // it has to be notified of form resize events in order to update the layout of its parts.
  // To do that, this method **must** be called from the host form method during the ``On Resize``
  // event.
  //
  //

ASSERT:C1129(Count parameters:C259=1)

$controlName:=$1

C_OBJECT:C1216($context)
$context:=Control_GetObjectContext ($controlName)
If (OB Is defined:C1231($context))
	
	C_OBJECT:C1216($controllerOrigin)
	$controllerOrigin:=FormObj_GetOrigin ($controlName)
	
	C_TEXT:C284($cvtCoordsName)
	$cvtCoordsName:=Command name:C538(1365)
	If ($cvtCoordsName="")  // (Application version<"1530")
		OB SET:C1220($context;"_origin_v15";$controllerOrigin)
	End if 
	
	EXECUTE METHOD IN SUBFORM:C1085($controlName;"Control_Layout_S";*;$context)
	
	C_OBJECT:C1216($areaFrame)
	$areaFrame:=OB Get:C1224($context;"_area_frame";Is object:K8:27)
	
	If (OB Is defined:C1231($areaFrame))
		
		C_OBJECT:C1216($areaRect)
		$areaRect:=RectObj_New (\
			PointObj_GetX ($controllerOrigin)+RectObj_GetX ($areaFrame);\
			PointObj_GetY ($controllerOrigin)+RectObj_GetY ($areaFrame);\
			RectObj_GetWidth ($areaFrame);\
			RectObj_GetHeight ($areaFrame))
		
		C_TEXT:C284($areaName)
		$areaName:=OB Get:C1224($context;"_area_name";Is text:K8:3)
		
		FormObj_SetRect ($areaName;$areaRect)
		
	End if 
	
	ImgControl_UpdateState ($controlName)
	
End if 
