//%attributes = {}
C_OBJECT:C1216($1; $config)
C_OBJECT:C1216($2; $metrics)
C_OBJECT:C1216($3; $layout)
C_LONGINT:C283($4; $width)
C_LONGINT:C283($5; $height)
C_OBJECT:C1216($0; $formDesc)

$config:=$1
$metrics:=$2
$layout:=$3
$width:=$4
$height:=$5

C_OBJECT:C1216($resourcesRef; $formJSONRef)
$resourcesRef:=FSRef_InitWithSystemPath(Get 4D folder:C485(Current resources folder:K5:16))
$formJSONRef:=FSRef_AppendNameArgs($resourcesRef; "Q2Pix"; "Q2ImgControl"; "NG"; "ImgControlNG-clean.json")


var $projectFolder; $formFolder : 4D:C1709.Folder
$projectFolder:=File:C1566(Structure file:C489(); fk platform path:K87:2).parent
$formFolder:=$projectFolder.folder("Sources").folder("Forms")

var $formFile : 4D:C1709.Folder
$formFile:=$formFolder.folder("ImgControlNG-Template").file("form.4DForm")


C_OBJECT:C1216($localForm)
If (File_LoadJSON($formFile; ->$localForm)/*FSRef_ParseJSONFile($formJSONRef; ->$localForm)*/)
	
	C_OBJECT:C1216($templateControls)
	$templateControls:=$localForm.pages[1].objects
	
	C_OBJECT:C1216($formControls)
	$formControls:=New object:C1471
	
	// ============================================
	// Menubar
	
	ImgCtlNG_BuildForm_Menubar($formControls; $config.menubar; $layout.menubar; $metrics; $templateControls)
	
	// ============================================
	// Toolbar
	
	ImgCtlNG_BuildForm_Toolbar($formControls; $config.toolbar; $layout.toolbar; $metrics; $templateControls)
	
	// ============================================
	// Sidebar
	
	ImgCtlNG_BuildForm_Sidebar($formControls; $config.sidebar; $layout.sidebar; $metrics; $templateControls)
	
	// ============================================
	// Subform
	
	$localForm.width:=$width
	$localForm.height:=$height
	$localForm.pages[1].objects:=$formControls
	$localForm.method:="ImgCtlNG_FormEvent"
	
	If (Is compiled mode:C492(*))
		$formDesc:=$localForm
	Else 
		
		//C_OBJECT($schemaFileRef; $schema)
		//$schemaFileRef:=FSRef_AppendNameArgs($resourcesRef; "Q2Pix"; "Q2ImgControl"; "NG"; "formsSchema.json")
		
		//FSRef_ParseJSONFile($schemaFileRef; ->$schema)
		
		
		var $appResources : 4D:C1709.Folder
		If (Is macOS:C1572)
			$appResources:=Folder:C1567(Application file:C491; fk platform path:K87:2).folder("Contents").folder("Resources")
		Else 
			$appResources:=Folder:C1567(Application file:C491; fk platform path:K87:2).folder("Resources")
		End if 
		
		var $formSchemaFile : 4D:C1709.File
		$formSchemaFile:=$appResources.file("formsSchema.json")
		
		var $schema : Object
		File_LoadJSON($formSchemaFile; ->$schema)
		
		C_OBJECT:C1216($validation)
		$validation:=JSON Validate:C1456($localForm; $schema)
		If ($validation.success)
			$formDesc:=$localForm
		Else 
			TRACE:C157
		End if 
		
	End if 
	
End if 

$0:=$formDesc

