//%attributes = {}
C_OBJECT:C1216($1;$config)
C_OBJECT:C1216($2;$metrics)
C_OBJECT:C1216($3;$layout)
C_LONGINT:C283($4;$width)
C_LONGINT:C283($5;$height)
C_OBJECT:C1216($0;$formDesc)

$config:=$1
$metrics:=$2
$layout:=$3
$width:=$4
$height:=$5

C_OBJECT:C1216($resourcesRef;$formJSONRef)
$resourcesRef:=FSRef_InitWithSystemPath (Get 4D folder:C485(Current resources folder:K5:16))
$formJSONRef:=FSRef_AppendNameArgs ($resourcesRef;"Q2Pix";"Q2ImgControl";"NG";"ImgControlNG-clean.json")

C_OBJECT:C1216($localForm)
If (FSRef_ParseJSONFile ($formJSONRef;->$localForm))
	
	C_OBJECT:C1216($templateControls)
	$templateControls:=$localForm.pages[1].objects
	
	C_OBJECT:C1216($formControls)
	$formControls:=New object:C1471
	
	  // ============================================
	  // Menubar
	
	C_OBJECT:C1216($menuLayout)
	For each ($menuLayout;$layout.menubar.menus)
		
		C_OBJECT:C1216($menuControl)
		$menuControl:=OB Copy:C1225($templateControls["menu"])
		
		$menuControl.left:=$layout.menubar.bounds.x+$menuLayout.bounds.x
		$menuControl.top:=$layout.menubar.bounds.y+$menuLayout.bounds.y
		$menuControl.width:=$menuLayout.bounds.width
		$menuControl.height:=$menuLayout.bounds.height
		$menuControl.text:=$menuLayout.menu.title
		$menuControl.method:="MenubarNG_MenuEvent"
		$menuControl.visibility:=Choose:C955($config.menubar.visible & $menuLayout.menu.visible;"visible";"hidden")
		$menuControl.popupPlacement:="none"
		
		$formControls[$menuLayout.menu.controlName]:=$menuControl
		
	End for each 
	
	  // Menubar separator
	
	C_OBJECT:C1216($menubarSepControl)
	$menubarSepControl:=OB Copy:C1225($templateControls["menubar_sep"])
	
	$menubarSepControl.left:=$layout.menubar.bounds.x
	$menubarSepControl.top:=$layout.menubar.bounds.y+$layout.menubar.bounds.height-1
	$menubarSepControl.width:=$layout.menubar.bounds.width
	$menubarSepControl.visibility:=Choose:C955($config.menubar.visible;"visible";"hidden")
	
	$formControls["menubar_sep"]:=$menubarSepControl
	
	  // ============================================
	  // Toolbar
	
	C_COLLECTION:C1488($toolsetRow)
	For each ($toolsetRow;$layout.toolbar.toolsets)
		
		C_OBJECT:C1216($toolsetLayout)
		For each ($toolsetLayout;$toolsetRow)
			
			C_OBJECT:C1216($toolsetControl)
			$toolsetControl:=OB Copy:C1225($templateControls["toolset"])
			
			$toolsetControl.left:=$layout.toolbar.bounds.x+$toolsetLayout.bounds.x
			$toolsetControl.top:=$layout.toolbar.bounds.y+$toolsetLayout.bounds.y
			$toolsetControl.width:=$toolsetLayout.bounds.width
			$toolsetControl.height:=$toolsetLayout.bounds.height
			$toolsetControl.visibility:=Choose:C955($config.toolbar.visible & $toolsetLayout.toolset.visible;"visible";"hidden")
			
			$formControls[$toolsetLayout.toolset.controlName]:=$toolsetControl
			
			C_OBJECT:C1216($toolLayout)
			For each ($toolLayout;$toolsetLayout.tools)
				
				C_TEXT:C284($commandID)
				$commandID:=$toolLayout.tool.command
				
				C_OBJECT:C1216($command)
				$command:=$config.commands[$commandID]
				
				C_TEXT:C284($toolType;$toolIcon;$toolTitle)
				  //$toolIcon:=Choose($toolLayout.icon#Null;$toolLayout.icon;Choose($command.icon#Null;$command.icon;""))
				  //$toolTitle:=Choose($toolLayout.title#Null;$toolLayout.title;Choose($command.title#Null;$command.title;""))
				$toolType:=$toolLayout.tool.type
				$toolIcon:=$toolLayout.tool.icon
				$toolTitle:=$toolLayout.tool.title
				
				C_OBJECT:C1216($toolControl)
				Case of 
					: ($toolType="button")
						$toolControl:=OB Copy:C1225($templateControls["tool_button"])
					: ($toolType="radio")
						$toolControl:=OB Copy:C1225($templateControls["tool_radio"])
					: ($toolType="check")
						$toolControl:=OB Copy:C1225($templateControls["tool_check"])
					: ($toolType="input")
						
						C_TEXT:C284($valueType)
						$valueType:=$toolLayout.tool.input.valueType
						
						Case of 
							: ($valueType="integer")
								$toolControl:=OB Copy:C1225($templateControls["tool_integer"])
							: ($valueType="number")
								$toolControl:=OB Copy:C1225($templateControls["tool_number"])
							: ($valueType="percent")
								$toolControl:=OB Copy:C1225($templateControls["tool_percent"])
						End case 
						
				End case 
				
				$toolControl.left:=$layout.toolbar.bounds.x+$toolLayout.bounds.x
				$toolControl.top:=$layout.toolbar.bounds.y+$toolLayout.bounds.y
				$toolControl.width:=$toolLayout.bounds.width
				$toolControl.height:=$toolLayout.bounds.height
				$toolControl.method:="ToolbarNG_ToolEvent"
				$toolControl.visibility:=Choose:C955($config.toolbar.visible & $toolsetLayout.toolset.visible;"visible";"hidden")
				
				If ($toolIcon#"")
					$toolControl.icon:=$toolIcon
				End if 
				
				If ($toolTitle#"")
					$toolControl.tooltip:=$toolTitle
				End if 
				
				$formControls[$toolLayout.tool.controlName]:=$toolControl
				
			End for each 
			
		End for each 
		
	End for each 
	
	  // Toolbar separator
	
	C_OBJECT:C1216($toolbarSepControl)
	$toolbarSepControl:=OB Copy:C1225($templateControls["toolbar_sep"])
	
	$toolbarSepControl.left:=$layout.toolbar.bounds.x
	$toolbarSepControl.top:=$layout.toolbar.bounds.y+$layout.toolbar.bounds.height-1
	$toolbarSepControl.width:=$layout.toolbar.bounds.width
	$toolbarSepControl.visibility:=Choose:C955($config.toolbar.visible;"visible";"hidden")
	
	$formControls["toolbar_sep"]:=$toolbarSepControl
	
	  // ============================================
	  // Sidebar
	
	  // Thumbnail view
	
	C_OBJECT:C1216($sidebarThumbsControl)
	$sidebarThumbsControl:=OB Copy:C1225($templateControls["sidebar_thumbs"])
	
	$sidebarThumbsControl.left:=$layout.sidebar.bounds.x
	$sidebarThumbsControl.top:=$layout.sidebar.bounds.y
	$sidebarThumbsControl.width:=$layout.sidebar.bounds.width
	$sidebarThumbsControl.height:=$layout.sidebar.bounds.height
	$sidebarThumbsControl.method:="SidebarNG_ThumbsEvent"
	$sidebarThumbsControl.visibility:=Choose:C955($config.sidebar.visible;"visible";"hidden")
	
	$formControls["sidebar_thumbs"]:=$sidebarThumbsControl
	
	  // TOC view
	
	C_OBJECT:C1216($sidebarTOCControl)
	$sidebarTOCControl:=OB Copy:C1225($templateControls["sidebar_toc"])
	
	$sidebarTOCControl.left:=$layout.sidebar.bounds.x
	$sidebarTOCControl.top:=$layout.sidebar.bounds.y
	$sidebarTOCControl.width:=$layout.sidebar.bounds.width
	$sidebarTOCControl.height:=$layout.sidebar.bounds.height
	$sidebarTOCControl.method:="SidebarNG_TOCEvent"
	$sidebarTOCControl.visibility:="hidden"
	
	$formControls["sidebar_toc"]:=$sidebarTOCControl
	
	  // Splitter
	
	C_OBJECT:C1216($sidebarSplitterControl)
	$sidebarSplitterControl:=OB Copy:C1225($templateControls["sidebar_splitter"])
	
	$sidebarSplitterControl.left:=$layout.sidebar.bounds.x+$layout.sidebar.bounds.width
	$sidebarSplitterControl.top:=$layout.sidebar.bounds.y
	$sidebarSplitterControl.width:=$metrics.sidebar.splitter.width
	$sidebarSplitterControl.height:=$layout.sidebar.bounds.height+1
	$sidebarSplitterControl.method:="SidebarNG_SplitterEvent"
	$sidebarSplitterControl.visibility:=Choose:C955($config.sidebar.visible;"visible";"hidden")
	
	$formControls["sidebar_splitter"]:=$sidebarSplitterControl
	
	  // ============================================
	  // Subform
	
	$localForm.width:=$width
	$localForm.height:=$height
	$localForm.pages[1].objects:=$formControls
	$localForm.method:="ImgCtlNG_FormEvent"
	
	If (Is compiled mode:C492(*))
		$formDesc:=$localForm
	Else 
		
		C_OBJECT:C1216($schemaFileRef;$schema)
		$schemaFileRef:=FSRef_AppendNameArgs ($resourcesRef;"Q2Pix";"Q2ImgControl";"NG";"formsSchema.json")
		
		FSRef_ParseJSONFile ($schemaFileRef;->$schema)
		
		C_OBJECT:C1216($validation)
		$validation:=JSON Validate:C1456($localForm;$schema)
		If ($validation.success)
			$formDesc:=$localForm
		Else 
			TRACE:C157
		End if 
		
	End if 
	
End if 

$0:=$formDesc

