// ====================================+++=
// Public API

Class constructor($controlName : Text)
	
	This:C1470.sourceConfig:=Null:C1517
	
	This:C1470.controlName:=""
	This:C1470.windowRef:=Current form window:C827
	This:C1470.formName:=Current form name:C1298
	This:C1470.processID:=Process_GetID()
	
	This:C1470.initiallyVisible:=False:C215
	This:C1470.formPage:=-1
	This:C1470.formStorageKey:="controlPages#"+String:C10(This:C1470.windowRef)+"#"+String:C10(This:C1470.processID)
	
	This:C1470.state:=New object:C1471()
	This:C1470.state.controlsBuilt:=False:C215
	This:C1470.state.layoutBuilt:=False:C215
	This:C1470.state.formBuilt:=False:C215
	This:C1470.state.layoutApplied:=False:C215
	This:C1470.state.pendingVisibility:=False:C215
	
	This:C1470.bounds:=Null:C1517
	This:C1470.controlWidth:=0
	This:C1470.controlHeight:=0
	
	This:C1470.config:=Null:C1517
	
	var $controlPtr : Pointer
	$controlPtr:=OBJECT Get pointer:C1124(Object named:K67:5; $controlName)
	
	If (Not:C34(Is nil pointer:C315($controlPtr)))
		
		This:C1470.controlName:=$controlName
		This:C1470.initiallyVisible:=OBJECT Get visible:C1075(*; $controlName)
		This:C1470.visible:=This:C1470.initiallyVisible
		
		OBJECT SET VISIBLE:C603(*; This:C1470.controlName; False:C215)
		This:C1470.state.pendingVisibility:=True:C214
		
		This:C1470.checkFormStorage()
		This:C1470.formPage:=Storage:C1525[This:C1470.formStorageKey][$controlName]
		
		var $left; $top; $right; $bottom : Integer
		OBJECT GET COORDINATES:C663(*; This:C1470.controlName; $left; $top; $right; $bottom)
		//This.bounds:=cs.Rect.new($left; $top; $right-$left; $bottom-$top)
		This:C1470.controlWidth:=$right-$left
		This:C1470.controlHeight:=$bottom-$top
		
		//This.setup($config)
		
		OBJECT SET VALUE:C1742(This:C1470.controlName; This:C1470)
		
	End if 
	
	
Function finalize()
	//
	
	
Function setup($config : Variant)->$success : Boolean
	
	This:C1470.config:=$config
	
	This:C1470.state.controlsBuilt:=This:C1470.buildControls()
	This:C1470.state.layoutBuilt:=This:C1470.buildLayout()
	
	If (This:C1470.onCurrentPage())
		
		This:C1470.state.formBuilt:=This:C1470.buildForm()
		This:C1470.state.layoutApplied:=This:C1470.applyLayout()
		
		If (This:C1470.state.pendingVisibility)
			OB_CallForm(This:C1470; This:C1470.restoreVisibility)
		End if 
		
		
	Else 
		
		This:C1470.state.formBuilt:=False:C215
		This:C1470.state.layoutApplied:=False:C215
		
	End if 
	
	$success:=True:C214
	
	
Function updateState()
	
	
	// ====================================+++=
	// Internal stuff
	
Function bootstrap()
	
	If (Not:C34(This:C1470.state.formBuilt))
		This:C1470.state.formBuilt:=This:C1470._buildForm()
	End if 
	
	If (Not:C34(This:C1470.state.layoutApplied))
		This:C1470.state.layoutApplied:=This:C1470._applyLayout()
	End if 
	
	
Function checkFormStorage()
	
	If (Storage:C1525[This:C1470.formStorageKey]=Null:C1517)
		
		var $formData : Object
		$formData:=New shared object:C1526()
		
		ARRAY TEXT:C222($controlNames; 0)
		ARRAY POINTER:C280($controlVars; 0)
		ARRAY LONGINT:C221($controlPages; 0)
		
		FORM GET OBJECTS:C898($controlNames; $controlVars; $controlPages)
		
		Use ($formData)
			
			C_LONGINT:C283($idx)
			For ($idx; 1; Size of array:C274($controlNames))
				$formData[$controlNames{$idx}]:=$controlPages{$idx}
			End for 
			
		End use 
		
		Use (Storage:C1525)
			
			Storage:C1525[This:C1470.formStorageKey]:=$formData
			
		End use 
		
	End if 
	
	
	
Function restoreVisibility()
	If (This:C1470.state.pendingVisibility)
		OBJECT SET VISIBLE:C603(*; This:C1470.controlName; This:C1470.initiallyVisible)
		This:C1470.state.pendingVisibility:=False:C215
	End if 
	
	
Function isVisible()->$visible : Boolean
	
	$visible:=This:C1470.visible
	
	
Function setVisible($visible : Boolean)
	If (This:C1470.pendingVisibility)
		This:C1470.initiallyVisible:=$visible
		This:C1470.visible:=$visible
	Else 
		This:C1470.visible:=$visible
		OBJECT SET VISIBLE:C603(*; This:C1470.controlName; This:C1470.visible)
	End if 
	
	
Function onCurrentPage()->$onPage : Boolean
	
	$onPage:=(This:C1470.formPage=0) | (This:C1470.formPage=FORM Get current page:C276())
	
	
	// ====================================+++=
	// Builders
	
Function buildControls()->$success : Boolean
	
	$success:=True:C214
	
	
Function buildLayout()->$success : Boolean
	
	$success:=True:C214
	
	
Function buildForm()->$success : Boolean
	
	$success:=OB_ExecuteInSubform(This:C1470.controlName; This:C1470; This:C1470._buildForm)
	
	
Function _buildForm()->$success : Boolean
	
	$success:=True:C214
	
	
Function applyLayout()->$success : Boolean
	
	$success:=OB_ExecuteInSubform(This:C1470.controlName; This:C1470; This:C1470._applyLayout)
	
	
Function _applyLayout()->$success : Boolean
	
	$success:=True:C214
	
	// ====================================+++=
	// Event handlers
	
Function _handleBootstrap()
	
	If (Not:C34(This:C1470.state.formBuilt))
		This:C1470.state.formBuilt:=This:C1470._buildForm()
	End if 
	
	If (Not:C34(This:C1470.state.layoutApplied))
		This:C1470.state.layoutApplied:=This:C1470._applyLayout()
	End if 
	
	If (This:C1470.state.pendingVisibility)
		OB_CallForm(This:C1470; This:C1470.restoreVisibility)
	End if 
	
	
Function _handleUnload()
	
	This:C1470.state.formBuilt:=False:C215
	This:C1470.state.layoutApplied:=False:C215
	
	
Function _handleResize()
	
	var $width; $height : Integer
	OBJECT GET SUBFORM CONTAINER SIZE:C1148($width; $height)
	This:C1470.controlWidth:=$width
	This:C1470.controlHeight:=$height
	
	This:C1470.state.layoutBuilt:=This:C1470.buildLayout()
	If (This:C1470.onCurrentPage())
		This:C1470.state.layoutApplied:=This:C1470._applyLayout()
	Else 
		This:C1470.state.layoutApplied:=False:C215
	End if 
	
	
Function _handleTimer()
	
	
	