//%attributes = {"shared":true}
C_LONGINT:C283($1; $areaRef)  // @param: The image area reference.

// @desc: Copy the current selection to the pasteboard.

// @doc: Copy the current marquee selection to the pasteboard.
// 
// Parameter ``areaRef`` is the plug-in area reference.
// 

ASSERT:C1129(Count parameters:C259=1)

$areaRef:=$1

C_OBJECT:C1216($pixelSelection)
$pixelSelection:=ImgArea_GetPixelSelection($areaRef)

If (OB Is defined:C1231($pixelSelection))
	
	C_TEXT:C284($imgDocRef)
	$imgDocRef:=ImgArea_GetDocument:P11667:41($areaRef)
	
	C_LONGINT:C283($frameIdx)
	$frameIdx:=ImgArea_GetFrameIndex:P11667:42($areaRef)
	
	C_TEXT:C284($docFormat)
	$docFormat:=ImgDoc_GetFormat:P11667:9($imgDocRef)
	
	C_OBJECT:C1216($formatInfo)
	$formatInfo:=ImgFormat_GetInfo($docFormat)
	
	C_BOOLEAN:C305($canEncode)
	$canEncode:=OB Get:C1224($formatInfo; "CanEncode"; Is boolean:K8:9)
	
	C_TEXT:C284($encodeFormat)
	If (Is macOS:C1572)
		$encodeFormat:=Choose:C955($canEncode; $docFormat; "TIFF")
	Else 
		$encodeFormat:="TIFF"
	End if 
	
	C_OBJECT:C1216($pbFormatInfo)
	$pbFormatInfo:=ImgFormat_GetInfo($encodeFormat)
	
	C_OBJECT:C1216($encodeOptions)
	OB SET:C1220($encodeOptions; "Format"; $encodeFormat)
	
	C_TEXT:C284($pbDocRef)
	$pbDocRef:=ImgDoc_CreateNew($encodeOptions)
	If ($pbDocRef#"")
		
		If (ImgDoc_InsertFrame($pbDocRef; 1; $imgDocRef; $frameIdx)=1)
			
			RasterFrame_Crop($pbDocRef; 1; $pixelSelection)
			
			C_BLOB:C604($encodedData)
			$encodedData:=ImgDoc_SaveInBLOB($pbDocRef; $encodeOptions)
			If (BLOB size:C605($encodedData)>0)
				
				C_TEXT:C284($pbUTI)
				$pbUTI:=OB Get:C1224($pbFormatInfo; "UTI"; Is text:K8:3)
				
				If (Is macOS:C1572 & ($pbUTI#""))
					
					CLEAR PASTEBOARD:C402
					APPEND DATA TO PASTEBOARD:C403($pbUTI; $encodedData)
					
				Else 
					C_PICTURE:C286($encodedPict)
					BLOB TO PICTURE:C682($encodedData; $encodedPict)
					
					If (Picture size:C356($encodedPict)>0)
						
						SET PICTURE TO PASTEBOARD:C521($encodedPict)
						
					End if 
				End if 
				
				
			End if 
			
		End if 
		
		ImgObj_Release:P11667:133($pbDocRef)
	End if 
	
End if   // (($frameCount>0) & ($frameIdx>0) & ($frameIdx<=$frameCount))

