//%attributes = {"shared":true}
C_LONGINT:C283($1;$areaRef)  // @param: The image area reference.
C_OBJECT:C1216($0;$pixelSelection)  // @param: The image area pixel selection rectangle.

  // @desc: Return the marquee pixel selection rectangle of a plug-in area.

  // @doc: Return the marquee pixel selection rectangle of a plug-in area.
  //
  // Parameter ``areaRef`` is the plug-in area reference.
  //
  // The selection rectangle is returned in ``pixelSelection`` as a ``RectObj``
  // expressed in pixels.
  // 
  // If the plug-in area is currently displaying a PDF document, an undefined
  // object is returned. Call :cc4d:cmethod:`ImgArea_GetPointSelection` in that case to retrieve
  // the selection rectangle expressed in ``points``.
  //
  // .. note:: This method is a convenience wrapper for the :cc4d:cmethod:`ImgArea_GetSelection` method.

ASSERT:C1129(Count parameters:C259=1)

$areaRef:=$1

C_OBJECT:C1216($selection)
$selection:=ImgArea_GetSelection ($areaRef)
If (OB Is defined:C1231($selection;"PixelSelection"))
	$pixelSelection:=OB Get:C1224($selection;"PixelSelection";Is object:K8:27)
End if 

$0:=$pixelSelection
