//%attributes = {"shared":true}
C_LONGINT:C283($1;$areaRef)  // @param: The image area reference.
C_TEXT:C284($2;$propName)  // @param: The property name.
C_POINTER:C301($3;$propValuePtr)  // @param: A pointer to the variable that will receive the property's value.
C_LONGINT:C283($0;$success)  // @param: Completion status: ``1`` on success, ``0`` otherwise.

  // @desc: Return the value of a plug-in area property.

  // @doc: Return the value of a plug-in area property.
  //
  // Parameter ``areaRef`` is the plug-in area reference.
  //
  // The name of the property to be returned is specified by ``propName``.
  //
  // The value of the property is returned in the variable pointed to by ``propValuePtr``.
  // The type of the variable receiving the property value must match that of the property.
  // The properties defined by the plug-in area are described in the following table.
  //
  // .. include:: /_shared/ImgArea_Properties.rsti
  //
  // .. note:: In addition to the properties defined by the plug-in area, applications can attach
  //           and access custom properties to a plug-in area for their own use.
  //           The type of plug-in area properties can be any of: ``Boolean``, ``Longint``,
  //           ``Real``, ``Text``, ``Object``, ``Boolean array``, ``Longint array``,
  //           ``Real array``, ``Text array``, ``Object array``.
  //
  // .. note:: This method is a convenience wrapper for the :cc4d:xmethod:`ImgArea_GetProperty_JSN` plug-in method.
  //           that de-serializes the property from JSON.

ASSERT:C1129(Count parameters:C259=3)

$areaRef:=$1
$propName:=$2
$propValuePtr:=$3
$success:=0

C_TEXT:C284($propJSON)
$propJSON:=ImgArea_GetProperty_JSN:P11667:60 ($areaRef;$propName)
If ($propJSON#"")
	$success:=Num:C11(JSON_Parse (->$propJSON;$propValuePtr))
End if 

$0:=$success
