//%attributes = {"shared":true}
C_LONGINT:C283($1;$areaRef)  // @param: The image area reference.
C_OBJECT:C1216($2;$pixelSelection)  // @param: The image area pixel selection rectangle.

  // @desc: Set the marquee pixel selection rectangle of a plug-in area.

  // @doc: Set the marquee pixel selection rectangle of a plug-in area.
  //
  // Parameter ``areaRef`` is the plug-in area reference.
  //
  // The selection rectangle is specified in ``pixelSelection`` as a ``RectObj``
  // expressed in pixels.
  // 
  // If the plug-in area is currently displaying a PDF document, this method
  // does nothing. Call :cc4d:cmethod:`ImgArea_SetPointSelection` in that case to set
  // the selection rectangle expressed in ``points``.
  //
  // .. note:: This method is a convenience wrapper for the :cc4d:cmethod:`ImgArea_SetSelection` method.

ASSERT:C1129(Count parameters:C259>=1)

$areaRef:=$1
If (Count parameters:C259>1)
	$pixelSelection:=$2
End if 

C_OBJECT:C1216($selection)
OB SET:C1220($selection;"PixelSelection";$pixelSelection)

ImgArea_SetSelection ($areaRef;$selection)
