//%attributes = {"shared":true}
C_OBJECT:C1216($1;$options)  // @param: Options. @optional
C_TEXT:C284($0;$imgDocRef)  // @param: The image document reference.

  // @desc: Create a reference to a new, empty image document.

  // @doc: Create a reference to a new, empty image document.
  //
  // The optional ``optionsJSON`` parameter is a 4D object that
  // may be used to specify the format of the new document:
  //
  // .. list-table::
  //    :widths: 25 10 20 45
  //    :header-rows: 1
  //
  //    * - Property name
  //      - Type
  //      - Default
  //      - Description
  //    * - ``Format``
  //      - ``String``
  //      - ``TIFF``
  //      - The format ID of the new document. Any of the formats supported by Q2Pix may be used.
  //
  // The image document reference is returned in ``imgDocRef``. The caller must release the document reference
  // when no longer needed with a call to :cc4d:xmethod:`ImgObj_Release`, otherwise there will be a memory
  // leak.
  //
  // .. note:: This method is a wrapper for the :cc4d:xmethod:`ImgDoc_CreateNew_JSN` plug-in method.
  //


If (Count parameters:C259>0)
	$options:=$1
End if 

C_TEXT:C284($optionsJSON)
If (OB Is defined:C1231($options))
	$optionsJSON:=JSON Stringify:C1217($options)
End if 

$imgDocRef:=ImgDoc_CreateNew_JSN:P11667:8 ($optionsJSON)

$0:=$imgDocRef
