//%attributes = {"shared":true}
C_TEXT:C284($1;$imgDocRef)  // @param: The image document reference.
C_TEXT:C284($0;$filePath)  // @param: The document's pathname.

  // @desc: Return the image document's pathname.

  // @doc: Return the absolute pathname of the image document referenced by ``imgDocRef``.
  // The returned pathname is in POSIX format.
  // 
  // If ``imgDocRef`` is an invalid image document reference or empty, an empty string is returned.
  //

ASSERT:C1129(Count parameters:C259=1)

$imgDocRef:=$1
$filePath:=""

C_OBJECT:C1216($props)
$props:=ImgDoc_GetProperties ($imgDocRef)
If (OB Is defined:C1231($props))
	$filePath:=OB Get:C1224($props;"FilePath";Is text:K8:3)
End if 

$0:=$filePath
