//%attributes = {"shared":true}
C_TEXT:C284($1;$imgDocRef)  // @param: The image document reference.
C_OBJECT:C1216($0;$propsObj)  // @param: The image document's properties.

  // @desc: Return the image document's properties.

  // @doc: Return the document-level properties of the image document referenced by ``imgDocRef``.
  // 
  // If ``imgDocRef`` is an invalid image document reference or empty, an undefined object is returned.
  //
  // The contents of object ``propsObj`` that receives the image document properties
  // vary depending on the kind of document (raster image or PDF).
  //
  // The following tables list the most common image document properties.
  //
  // .. include:: /_shared/ImgDoc_Properties.rsti
  //
  // .. note:: This method is a convenience wrapper for the :cc4d:xmethod:`ImgDoc_GetProperties_JSN`
  //           plug-in method.
  //

ASSERT:C1129(Count parameters:C259=1)

$imgDocRef:=$1

C_TEXT:C284($propsJSON)

$propsJSON:=ImgDoc_GetProperties_JSN:P11667:10 ($imgDocRef)
If ($propsJSON#"")
	$propsObj:=JSON Parse:C1218($propsJSON;Is object:K8:27)
End if 

$0:=$propsObj
