//%attributes = {"shared":true}
C_TEXT:C284($1;$imgDocRef)  // @param: The image document reference.
C_OBJECT:C1216($2;$options)  // @param: Options. @optional
C_BLOB:C604($0;$imageData)  // @param: The output image.

  // @desc: Save the image document into a BLOB.

  // @doc: Save the image document into a BLOB.
  // 
  // Parameter ``imgDocRef`` is the image document reference.
  // 
  // The output image is returned in ``imageData``.
  // 
  // The optional parameter ``options`` is a 4D object through which various saving options
  // can be specified:
  // 
  // .. include:: /_shared/ImgDoc_SaveToBLOB_General_Options.rsti
  // 
  // .. include:: /_shared/ImgDoc_Save_Encoding_Options.rsti
  // 
  // .. include:: /_shared/ImgDoc_Saving_Progress_Options.rsti
  // 
  // .. note:: This method is a convenience wrapper for the :cc4d:xmethod:`ImgDoc_SaveInBLOB_JSN`
  //           plug-in method.
  //

ASSERT:C1129(Count parameters:C259>=1)

$imgDocRef:=$1
If (Count parameters:C259>1)
	$options:=$2
End if 

C_TEXT:C284($optionsJSON)
If (OB Is defined:C1231($options))
	$optionsJSON:=JSON Stringify:C1217($options)
End if 

$imageData:=ImgDoc_SaveInBLOB_JSN:P11667:17 ($imgDocRef;$optionsJSON)

$0:=$imageData
