//%attributes = {"shared":true}
C_TEXT:C284($1;$imgDocRef)  // @param: The image document reference.
C_TEXT:C284($2;$filePath)  // @param: The destination file path. @optional
C_OBJECT:C1216($3;$options)  // @param: Saving options. @optional
C_LONGINT:C283($0;$success)  // @param: Completion status: ``1`` on success, ``0`` otherwise.

  // @desc: Save the image document to a file.

  // @doc: Save the image document to a file.
  // 
  // Parameter ``imgDocRef`` is the image document reference.
  // 
  // The full pathname of the destination file is specified in the ``destFilePath`` parameter.
  // If omitted or set to an empty string, ``destFilePath`` defaults to the pathname of the
  // document file. The pathname may be in either ``POSIX`` (recommended) or ``System`` format.
  // 
  // The optional parameter ``options`` is a 4D object through which various saving options
  // can be specified:
  // 
  // .. include:: /_shared/ImgDoc_SaveToFile_General_Options.rsti
  // 
  // .. include:: /_shared/ImgDoc_Save_Encoding_Options.rsti
  // 
  // .. include:: /_shared/ImgDoc_Saving_Progress_Options.rsti
  // 
  // .. note:: This method is a convenience wrapper for the :cc4d:xmethod:`ImgDoc_SaveInFile_JSN`
  //           plug-in method.
  //

ASSERT:C1129(Count parameters:C259>=1)

$imgDocRef:=$1
If (Count parameters:C259>1)
	$filePath:=$2
End if 
If (Count parameters:C259>2)
	$options:=$3
End if 
$success:=0

C_TEXT:C284($optionsJSON)
If (OB Is defined:C1231($options))
	$optionsJSON:=JSON Stringify:C1217($options)
End if 

$success:=ImgDoc_SaveInFile_JSN:P11667:16 ($imgDocRef;$filePath;$optionsJSON)

$0:=$success
