//%attributes = {"shared":true}
C_POINTER:C301($1;$encoderIDsPtr)  // @param: Pointer to the encoder ID array.
C_POINTER:C301($2;$encoderNamesPtr)  // @param: Pointer to the encoder name array. @optional

  // @desc: Return a list of the formats than can encode.

  // @doc: Return the IDs, and optionally the names, of the formats than can encode.
  // 
  // Parameter ``encoderIDsPtr`` is a pointer to a text array.
  // On completion the text array will be contain the IDs of the formats that can encode.
  //
  // The optional parameter ``encoderNamesPtr`` is also a pointer to a text array.
  // If specified, the array will be loaded with the respective format names.
  //

ASSERT:C1129(Count parameters:C259>=1)

$encoderIDsPtr:=$1
ASSERT:C1129(Not:C34(Is nil pointer:C315($encoderIDsPtr)))
ASSERT:C1129(Type:C295($encoderIDsPtr->)=Text array:K8:16)

If (Count parameters:C259>1)
	$encoderNamesPtr:=$2
	If (Not:C34(Is nil pointer:C315($encoderNamesPtr)))
		ASSERT:C1129(Not:C34(Is nil pointer:C315($encoderNamesPtr)))
		ASSERT:C1129(Type:C295($encoderNamesPtr->)=Text array:K8:16)
	End if 
End if 

ARRAY TEXT:C222($formatIDs;0)
ImgFormat_GetList:P11667:142 ($formatIDs)

ARRAY TEXT:C222($encoderIDsPtr->;0)
If (Not:C34(Is nil pointer:C315($encoderNamesPtr)))
	ARRAY TEXT:C222($encoderNamesPtr->;0)
End if 

C_LONGINT:C283($idx)
For ($idx;1;Size of array:C274($formatIDs))
	
	C_OBJECT:C1216($formatInfo)
	$formatInfo:=ImgFormat_GetInfo ($formatIDs{$idx})
	If (OB Get:C1224($formatInfo;"CanEncode";Is boolean:K8:9))
		APPEND TO ARRAY:C911($encoderIDsPtr->;$formatIDs{$idx})
		If (Not:C34(Is nil pointer:C315($encoderNamesPtr)))
			APPEND TO ARRAY:C911($encoderNamesPtr->;OB Get:C1224($formatInfo;"Name";Is text:K8:3))
		End if 
	End if 
	
End for 

