//%attributes = {"shared":true}
C_POINTER:C301($1;$formatArrayPtr)  // @param: List of format IDs. @optional
C_TEXT:C284($0;$extFilter)  // @param: The file extension filter.

  // @desc: Returns a file extension filter string.

  // @doc: Returns a file extension filter string suitable
  // for passing to the **Select document** 4D command.
  // 
  // By default the filter strings contains file extensions for all
  // supported formats.
  //
  // To get a filter string for a subset of the supported formats,
  // pass in ``formatArrayPtr`` a pointer to a text array containing
  // the format IDs.


ASSERT:C1129(Count parameters:C259<=1)

If (Count parameters:C259>0)
	$formatArrayPtr:=$1
End if 

$extFilter:=""

ARRAY TEXT:C222($formatIDs;0)
If (Not:C34(Is nil pointer:C315($formatArrayPtr)))
	COPY ARRAY:C226($formatArrayPtr->;$formatIDs)
Else 
	ImgFormat_GetList:P11667:142 ($formatIDs)
End if 

C_LONGINT:C283($formatCount)
$formatCount:=Size of array:C274($formatIDs)

C_LONGINT:C283($ii)

For ($ii;1;$formatCount)
	
	C_OBJECT:C1216($formatInfo)
	$formatInfo:=ImgFormat_GetInfo ($formatIDs{$ii})
	
	If (OB Is defined:C1231($formatInfo))
		
		ARRAY TEXT:C222($exts;0)
		OB GET ARRAY:C1229($formatInfo;"Extensions";$exts)
		
		C_LONGINT:C283($jj)
		
		For ($jj;1;Size of array:C274($exts))
			
			C_TEXT:C284($anExt)
			$anExt:=$exts{$jj}
			
			If ($anExt#"")
				If (Substring:C12($anExt;1;1)#".")
					$anExt:="."+$anExt
				End if 
				$extFilter:=$extFilter+";"+$anExt
			End if 
			
		End for 
		
	End if 
	
End for 

If ($extFilter#"")  // Strip leading ";"
	$extFilter:=Substring:C12($extFilter;2)
End if 

$0:=$extFilter
