//%attributes = {"shared":true}
C_TEXT:C284($1;$imgDocRef)  // @param: The image document reference.
C_LONGINT:C283($2;$frameIdx)  // @param: The index of the image frame. @optional
C_OBJECT:C1216($3;$options)  // @param: Thumbnail creation and encoding options. @optional
C_PICTURE:C286($0;$thumb)  // @param: The thumbnail picture.

  // @desc: Create a thumbnail from an image frame and return it as a picture.

  // @doc: This method is just a wrapper for the :cc4d:cmethod:`ImgFrame_CreateThumb` component method.
  // See the documentation of the :cc4d:cmethod:`ImgFrame_CreateThumb` method for details.

ASSERT:C1129(Count parameters:C259>=1)

$imgDocRef:=$1
If (Count parameters:C259>1)
	$frameIdx:=$2
End if 
If (Count parameters:C259>2)
	$options:=$3
End if 

If ($frameIdx=0)
	$frameIdx:=1
End if 

C_BLOB:C604($thumbBLOB)
$thumbBLOB:=ImgFrame_CreateThumb ($imgDocRef;$frameIdx;$options)
If (BLOB size:C605($thumbBLOB)>0)
	BLOB TO PICTURE:C682($thumbBLOB;$thumb)
End if 

$0:=$thumb
