//%attributes = {"shared":true}
C_TEXT:C284($1;$imgDocRef)  // @param: The image document reference.
C_LONGINT:C283($2;$frameIdx)  // @param: The index of the image frame. @optional
C_OBJECT:C1216($0;$frameProps)  // @param: The image frame properties.

  // @desc: Return the properties of an image frame.

  // @doc: Return the frame-level properties of an image frame.
  //
  // Parameter ``imgDocRef`` is the image document reference. This method works with both raster
  // images and PDF documents.
  //
  // Parameter ``frameIdx`` is the index of the image frame. Passing ``0`` or omitting this
  // parameter is the same as passing 1.
  //
  // The image frame properties are returned in the ``frameProps`` 4D object.
  //
  // The contents of ``frameProps`` may very depending on the image format and on the
  // specific image. Some common properties are listed in the following tables:
  //
  // .. include:: /_shared/ImgFrame_Properties.rsti
  //
  // .. note:: This method is a convenience wrapper for the :cc4d:xmethod:`ImgFrame_GetProperties_JSN`
  //           plug-in method.

ASSERT:C1129(Count parameters:C259>=1)

$imgDocRef:=$1
If (Count parameters:C259>1)
	$frameIdx:=$2
End if 

If ($frameIdx=0)
	$frameIdx:=1
End if 

C_TEXT:C284($framePropsJSON)

$framePropsJSON:=ImgFrame_GetProperties_JSN:P11667:20 ($imgDocRef;$frameIdx)
If ($framePropsJSON#"")
	$frameProps:=JSON Parse:C1218($framePropsJSON;Is object:K8:27)
End if 

$0:=$frameProps
