//%attributes = {"shared":true}
C_TEXT:C284($1;$sourceID)  // @param: The image source ID.
C_OBJECT:C1216($2;$options)  // @param: Acquisition options. @optional
C_TEXT:C284($0;$imagePath)  // @param: The full pathname of the acquired image.

  // @desc: Acquire a single image from an image source.

  // @doc: Acquire a single image from an image source and return its full pathname.
  //
  // Parameter ``sourceID`` is the ID of the image source.
  //
  // The optional parameter ``options`` is a 4D object that can used to specify options
  // for the acquisition session:
  //
  // .. include:: /_shared/ImgSource_AcquireImage_Options.rsti
  //
  // The full pathname of the acquired image is returned in ``imagePath``.
  // If the user cancels the acquisition session, or if there is an error, ``imagePath``
  // is set to an empty string.

ASSERT:C1129(Count parameters:C259>=1)

$sourceID:=$1
If (Count parameters:C259>1)
	$options:=$2
End if 
$imagePath:=""

C_OBJECT:C1216($results)
$results:=ImgSource_Acquire ($sourceID;$options)
If (OB Is defined:C1231($results))
	
	ARRAY TEXT:C222($images;0)
	OB GET ARRAY:C1229($results;"Images";$images)
	If (Size of array:C274($images)>0)
		$imagePath:=$images{1}
	End if 
	
End if 

$0:=$imagePath

