//%attributes = {"shared":true}
C_TEXT:C284($1;$imgDocRef)  // @param: The raster document reference.
C_LONGINT:C283($2;$frameIdx)  // @param: The index of the raster frame.
C_LONGINT:C283($0;$success)  // @param: Completion status: ``1`` on success, ``0`` otherwise.

  // @desc: Let the user adjust the size of a raster frame.

  // @doc: Display a dialog where the user can change the pixel size and/or
  // resolution of a raster frame, and apply the specified changes.
  //
  // Parameter ``imgDocRef`` is the raster document reference. If ``imgDocRef`` refers
  // to a PDF document, this method does nothing.
  //
  // Parameter ``frameIdx`` is the index of the image frame.
  //
  // On successful completion ``1`` is returned in ``success``, ``0`` otherwise.
  //

ASSERT:C1129(Count parameters:C259=2)

$imgDocRef:=$1
$frameIdx:=$2
$success:=0

C_OBJECT:C1216($pixelSize;$dpiSize)
$pixelSize:=RasterFrame_GetPixelSize ($imgDocRef;$frameIdx)
$dpiSize:=RasterFrame_GetDPISize ($imgDocRef;$frameIdx)

If (ImgDlog_RasterSize (->$pixelSize;->$dpiSize)=1)
	
	RasterFrame_Resize ($imgDocRef;$frameIdx;$pixelSize;$dpiSize)
	
	$success:=Num:C11(Not:C34(OB Is defined:C1231(ImgErr_GetInfo )))
	
End if 

$0:=$success
