//%attributes = {"shared":true}
C_TEXT:C284($1; $imgDocRef)  // @param: The raster document reference.
C_LONGINT:C283($2; $frameIdx)  // @param: The index of the raster frame. @optional
C_LONGINT:C283($0; $orientation)  // @param: The raster frame's orientation.

// @desc: Return the orientation of a raster frame.

// @doc: Return the orientation of the raster frame specified by ``imgDocRef`` and ``frameIdx``
//
// Parameter ``imgDocRef`` is the raster document reference. If ``imgDocRef`` refers
// to a PDF document, ``0`` is returned.
//
// Parameter ``frameIdx`` is the index of the image frame. Passing ``0`` or omitting this
// parameter is the same as passing 1.
//
// The raster frame's orientation is returned in ``orientation``, and its value is one
// of the Image Orientation constants.
//

ASSERT:C1129(Count parameters:C259>=1)

$imgDocRef:=$1
If (Count parameters:C259>1)
	$frameIdx:=$2
End if 

If ($frameIdx=0)
	$frameIdx:=1
End if 

$orientation:=0

C_OBJECT:C1216($geometry)
$geometry:=ImgFrame_GetGeometry($imgDocRef; $frameIdx)
If (OB Is defined:C1231($geometry))
	$orientation:=Choose:C955($geometry["Orientation"]#Null:C1517; $geometry["Orientation"]; 0)
End if 

$0:=$orientation
