//%attributes = {"shared":true}
C_TEXT:C284($1;$imgDocRef)  // @param: The raster document reference.
C_LONGINT:C283($2;$frameIdx)  // @param: The index of the raster frame.
C_TEXT:C284($3;$xmpDataRef)  // @param: The XMP data reference.

  // @desc: Assign XMP data to a raster frame.

  // @doc: Assign XMP data to the raster frame specified by ``imgDocRef`` and ``frameIdx``.
  //
  // Parameter ``imgDocRef`` is the raster document reference. If ``imgDocRef`` refers
  // to a PDF document, this method does nothing.
  //
  // Parameter ``frameIdx`` is the index of the image frame.
  //
  // The XMP data reference is passed in the ``xmpDataRef`` parameter.
  //
  // .. note:: This method is a convenience wrapper for the :cc4d:cmethod:`RasterFrame_PushFilter` method
  //           that pushes the ``XMP`` filter into the raster frame's edit stack.

ASSERT:C1129(Count parameters:C259=3)

$imgDocRef:=$1
$frameIdx:=$2
$xmpDataRef:=$3

If ($xmpDataRef#"")
	
	C_OBJECT:C1216($filterParams)
	OB SET:C1220($filterParams;"XMPData";$xmpDataRef)
	
	RasterFrame_PushFilter ($imgDocRef;$frameIdx;"XMP";$filterParams)
	
End if 

