//%attributes = {"shared":true}
C_OBJECT:C1216($1;$rectObj)  // @param: The ``RectObj`` object.
C_OBJECT:C1216($0;$sizeObj)  // @param: The rect's size.

  // @desc: Return the rect's size.

  // @doc: Return the rect's size.
  //
  // The ``RectObj`` object is passed in the ``rectObj`` parameter.
  //
  // The rect's size is returned in ``sizeObj`` as a ``SizeObj`` object.
  //

ASSERT:C1129(Count parameters:C259=1)

$rectObj:=$1

ASSERT:C1129(OB Is defined:C1231($rectObj;"X"))
ASSERT:C1129(OB Is defined:C1231($rectObj;"Y"))
ASSERT:C1129(OB Is defined:C1231($rectObj;"Width"))
ASSERT:C1129(OB Is defined:C1231($rectObj;"Height"))

C_REAL:C285($width;$height)
$width:=OB Get:C1224($rectObj;"Width";Is real:K8:4)
$height:=OB Get:C1224($rectObj;"Height";Is real:K8:4)

$sizeObj:=SizeObj_New ($width;$height)

$0:=$sizeObj
