//%attributes = {"shared":true}
C_OBJECT:C1216($1;$rectObj)  // @param: The ``RectObj`` object.
C_REAL:C285($0;$x)  // @param: The X coordinate of ``pointObj``'s origin.

  // @desc: Return the X coordinate of the origin of a RectObj object.

  // @doc: Return the X coordinate of the origin of a ``RectObj`` object.
  //
  // The ``RectObj`` object is passed in the ``rectObj`` parameter.
  //
  // The X coordinate of ``rectObj``'s origin is returned in ``x``.
  //

ASSERT:C1129(Count parameters:C259=1)

$rectObj:=$1
$x:=0

ASSERT:C1129(OB Is defined:C1231($rectObj;"X"))
ASSERT:C1129(OB Is defined:C1231($rectObj;"Y"))
ASSERT:C1129(OB Is defined:C1231($rectObj;"Width"))
ASSERT:C1129(OB Is defined:C1231($rectObj;"Height"))

$x:=OB Get:C1224($rectObj;"X";Is real:K8:4)

$0:=$x
