//%attributes = {"invisible":true}
#DECLARE($subPath : Text; $filter : Text)->$resFiles : Collection

$filter:=Choose:C955(Count parameters:C259>1; $filter; "")

$resFiles:=New collection:C1472()

// ===================================
// Fetch host db resources

var $hostResourceFiles : Collection

If (Structure file:C489#Structure file:C489(*))
	
	var $hostDir : 4D:C1709.Folder
	$hostDir:=Folder:C1567(fk resources folder:K87:11; *).folder($subPath)
	
	$hostResourceFiles:=Folder_GetFiles($hostDir; True:C214; $filter)
	
End if 

// ===================================
// Fetch component resources

var $compDir : 4D:C1709.Folder
$compDir:=Folder:C1567(fk resources folder:K87:11).folder($subPath)

var $compResourceFiles : Collection
$compResourceFiles:=Folder_GetFiles($compDir; True:C214; $filter)

// ===================================
// Merge resources
// Host resources override component resources with the same name.

C_OBJECT:C1216($resourcesByName)
$resourcesByName:=New object:C1471()

var $resourceFile : 4D:C1709.File
For each ($resourceFile; $compResourceFiles)
	$resourcesByName[$resourceFile.fullName]:=$resourceFile
End for each 

// Sort by name

var $name : Text
For each ($name; OB Keys:C1719($resourcesByName).sort())
	$resFiles.push($resourcesByName[$name])
End for each 

