//%attributes = {"invisible":true}
C_OBJECT:C1216($1;$paneContext)
C_TEXT:C284($2;$propName)
C_OBJECT:C1216($3;$propSpec)

$paneContext:=$1
$propName:=$2
$propSpec:=$3

ASSERT:C1129(OB Is defined:C1231($paneContext))

C_TEXT:C284($specType)
$specType:=OB Get:C1224($propSpec;"Type";Is text:K8:3)

Case of 
	: (Spec_IsSimple ($specType))
		
		Pane_BuildSimpleSection ($paneContext;$propName;$propSpec)
		
	: (Spec_IsLangAlt ($specType))
		
		Pane_BuildLangAltSection ($paneContext;$propName;$propSpec)
		
	: (Spec_IsSequence ($specType))
		
		C_TEXT:C284($elemType)
		$elemType:=OB Get:C1224($propSpec;"ElemType";Is text:K8:3)
		If (Spec_IsSimple ($elemType))
			Pane_BuildSeqSection ($paneContext;$propName;$propSpec)
		Else 
			ASSERT:C1129(False:C215;"FIXME: complex sequence types")
		End if 
		
	: (Spec_IsStruct ($specType))
		
		C_TEXT:C284($xmpDataRef)
		$xmpDataRef:=OB Get:C1224($paneContext;"xmp_edit_data";Is text:K8:3)
		
		ARRAY TEXT:C222($subPropNames;0)
		XMPData_GetPropertyNames:P11667:80 ($xmpDataRef;$propName;$subPropNames)
		SORT ARRAY:C229($subPropNames;>)
		
		C_OBJECT:C1216($subSpecs)
		$subSpecs:=OB Get:C1224($propSpec;"Contents";Is object:K8:27)
		
		C_LONGINT:C283($idx)
		
		For ($idx;1;Size of array:C274($subPropNames))
			
			C_TEXT:C284($aSubName)
			$aSubName:=$subPropNames{$idx}
			
			If (OB Is defined:C1231($subSpecs;$aSubName))
				
				C_OBJECT:C1216($aSubSpec)
				$aSubSpec:=OB Get:C1224($subSpecs;$aSubName;Is object:K8:27)
				
				Pane_BuildProperty ($paneContext;$propName+"/"+$aSubName;$aSubSpec)
				
			Else 
				TRACE:C157
			End if 
			
		End for 
		
	: (Spec_IsTypeAlias ($specType))
		
		ASSERT:C1129(False:C215;"FIXME: alias types")
		
	Else 
		
		ASSERT:C1129(False:C215;"Unhandled type")
		
End case 

