//%attributes = {"invisible":true}
C_OBJECT:C1216($1; $paneContext)
$paneContext:=$1

ASSERT:C1129(OB Is defined:C1231($paneContext))

C_TEXT:C284($xmpDataRef)
$xmpDataRef:=OB Get:C1224($paneContext; "xmp_edit_data"; Is text:K8:3)

C_TEXT:C284($prefix)
$prefix:=OB Get:C1224($paneContext; "xmp_ns_prefix"; Is text:K8:3)

ARRAY TEXT:C222($rootProps; 0)
XMPData_GetPropertyNames:P11667:80($xmpDataRef; $prefix; $rootProps)

C_LONGINT:C283($propCount)
$propCount:=Size of array:C274($rootProps)

C_OBJECT:C1216($propertiesDict)
ARRAY TEXT:C222($propertyNames; 0)

C_LONGINT:C283($idx)

For ($idx; 1; $propCount)
	
	C_TEXT:C284($propName)
	$propName:=$rootProps{$idx}
	
	C_LONGINT:C283($propType)
	$propType:=XMPData_GetPropertyType:P11667:82($xmpDataRef; $propName)
	
	C_OBJECT:C1216($propSpec)
	// Lookup the property spec in the schema specs
	If (OB Is defined:C1231(<>gXMPPropertiesFlat; $propName))
		$propSpec:=OB Get:C1224(<>gXMPPropertiesFlat; $propName; Is object:K8:27)
	Else 
		
		// If no property spec found in the schema specs, build
		// a minimal spec from the element type and contents.
		
		$propSpec:=New object:C1471()
		
		C_LONGINT:C283($elemType)
		
		Case of 
			: ($propType=kXMPPropTypeSimple)
				
				OB SET:C1220($propSpec; "Type"; "text")
				OB SET:C1220($propSpec; "External"; <>gXMPUnknownPropsAreExternal)
				
			: ($propType=kXMPPropTypeLangAltArray)
				
				OB SET:C1220($propSpec; "Type"; "LangAlt")
				OB SET:C1220($propSpec; "External"; <>gXMPUnknownPropsAreExternal)
				
			: ($propType=kXMPPropTypeArray)
				
				OB SET:C1220($propSpec; "Type"; "array")
				
				$elemType:=XMPData_GetPropertyType:P11667:82($xmpDataRef; $propName+"[1]")
				Case of 
					: ($elemType=kXMPPropTypeSimple)
						OB SET:C1220($propSpec; "ElemType"; "text")
					: ($elemType=kXMPPropTypeLangAltArray)
						OB SET:C1220($propSpec; "ElemType"; "LangAlt")
					: ($elemType=kXMPPropTypeStructure)
						OB SET:C1220($propSpec; "ElemType"; "struct")
				End case 
				
				OB SET:C1220($propSpec; "External"; <>gXMPUnknownPropsAreExternal)
				
			: ($propType=kXMPPropTypeBag)
				
				OB SET:C1220($propSpec; "Type"; "bag")
				
				$elemType:=XMPData_GetPropertyType:P11667:82($xmpDataRef; $propName+"[1]")
				
				Case of 
					: ($elemType=kXMPPropTypeSimple)
						OB SET:C1220($propSpec; "ElemType"; "text")
					: ($elemType=kXMPPropTypeLangAltArray)
						OB SET:C1220($propSpec; "ElemType"; "LangAlt")
					: ($elemType=kXMPPropTypeStructure)
						OB SET:C1220($propSpec; "ElemType"; "struct")
				End case 
				
				OB SET:C1220($propSpec; "External"; <>gXMPUnknownPropsAreExternal)
				
			: ($propType=kXMPPropTypeStructure)
				
				OB SET:C1220($propSpec; "Type"; "struct")
				OB SET:C1220($propSpec; "External"; <>gXMPUnknownPropsAreExternal)
				
		End case 
		
	End if 
	
	C_OBJECT:C1216($propInfo)
	OB SET:C1220($propInfo; "Name"; $propName)
	OB SET:C1220($propInfo; "Type"; $propType)
	If (OB Is defined:C1231($propSpec))
		OB SET:C1220($propInfo; "Spec"; OB Copy:C1225($propSpec))
	End if 
	
	OB SET:C1220($propertiesDict; $propName; OB Copy:C1225($propInfo))
	
	APPEND TO ARRAY:C911($propertyNames; $propName)
	
End for 

OB SET:C1220($paneContext; "Properties"; $propertiesDict)
OB SET ARRAY:C1227($paneContext; "prop_names"; $propertyNames)

