//%attributes = {"shared":true}
C_TEXT:C284($1;$xmpDataRef)  // @param: The XMP data reference.
C_TEXT:C284($2;$arrayPropPath)  // @param: The path of the XMP *Array* or *Bag* property.
C_POINTER:C301($3;$itemArrayPtr)  // @param: Pointer to the text array that will receive the property item values.

  // @desc: Load the contents of an *Array* or *Bag* property containing simple
  // values into a 4D text array.

  // @doc: This is a convenience method that given an XMP data reference and
  // the path to an *Array* or *Bag* property containing simple values, loads all
  // property item values into a 4D text array.
  //

$xmpDataRef:=$1
$arrayPropPath:=$2
$itemArrayPtr:=$3

Array_Clear ($itemArrayPtr)  // Empty the destination 4D array

C_LONGINT:C283($itemCount;$idx)
$itemCount:=XMPData_GetArrayCount:P11667:88 ($xmpDataRef;$arrayPropPath)

For ($idx;1;$itemCount)
	
	C_TEXT:C284($itemPath;$itemValue)
	$itemPath:=$arrayPropPath+"["+String:C10($idx)+"]"
	
	$itemValue:=XMPData_GetSimplePropertyValue:P11667:84 ($xmpDataRef;$itemPath)
	
	APPEND TO ARRAY:C911($itemArrayPtr->;$itemValue)
	
End for 
