//%attributes = {"shared":true}
C_TEXT:C284($1;$xmpDataRef)  // @param: The XMP data reference.
C_TEXT:C284($2;$langAltPropPath)  // @param: The path of the XMP *LangAlt* property.
C_POINTER:C301($3;$langArrayPtr)  // @param: Pointer to the text array that will receive the property languages.
C_POINTER:C301($4;$valueArrayPtr)  // @param: Pointer to the text array that will receive the property values.

  // @desc: Load the languages and values of a *LangAlt* property into
  // two 4D text arrays.

  // @doc: This is a convenience method that given an XMP data reference and
  // the path to a 'LangAlt' property, loads all languages and values into
  // two 4D text arrays.
  //
  // The first element in the languages array will always be "x-default",
  // and the first element in the values array will always be the corresponding
  // default value.

$xmpDataRef:=$1
$langAltPropPath:=$2
$langArrayPtr:=$3
$valueArrayPtr:=$4

  // Empty the destination 4D arrays
Array_Clear ($langArrayPtr)
Array_Clear ($valueArrayPtr)

ARRAY TEXT:C222($localLangArray;0)
XMPData_GetPropertyLanguages:P11667:90 ($xmpDataRef;$langAltPropPath;$localLangArray)

C_LONGINT:C283($langCount;$idx)
$langCount:=Size of array:C274($localLangArray)

For ($idx;1;$langCount)
	
	C_TEXT:C284($lang;$value)
	$lang:=$localLangArray{$idx}
	
	$value:=XMPData_GetLangAltPropValue:P11667:91 ($xmpDataRef;$langAltPropPath;$lang)
	
	APPEND TO ARRAY:C911($langArrayPtr->;$lang)
	APPEND TO ARRAY:C911($valueArrayPtr->;$value)
	
End for 
